ITEMS = {
	[0] = {
		name = ""
	}, 

	[1] = {
		name = "Apple", 
		article = "an", 
		desc = "No visible worms, heals 10-20.", 
		r = 255, g = 0, b = 0, 
		action = {"eat", "hold"}, 
		slot = 9, 
		food = function() return math.random(10,20) end, 
		fimage = "gfx/weiwen/apple.png", 
		func = {eat, equip},
	}, 

	[2] = {
		name = "Torch",
		plural = "torches", 
		desc = "Allows you to see clearly in the dark.",
		r = 191, g = 213, b = 128,
		action = "hold", 
		slot = 8, 
		fimage = "gfx/weiwen/torch.png",
		eimage = "gfx/sprites/flare3.bmp",
		escalex = 3, 
		escaley = 3, 
		blend = 1, 
		static = 1, 
		func = equip,
	}, 

	[3] = {
		name = "Hourglass", 
		plural = "hourglasses", 
		article = "an", 
		r = 180, g = 180, b = 180, 
		action = {"wear","check time"}, 
		slot = 8, 
		func = {equip, function(id) msg2(id,ITEMS[3].desc) end},
	},
	
	[4] = {
		name = "Cheese", 
		desc = "A solid food prepared from the pressed curd of milk, heals 10-20.", 
		r = 255, g = 255, b = 0, 
		action = {"eat", "hold"}, 
		slot = 9, 
		food = function() return math.random(10,20) end, 
		fimage = "gfx/weiwen/cheese.png", 
		func = {eat, equip},
	}, 

	[5] = { 
                name = "Big Pizza", 
                desc = "Italian open pie made of thin bread dough spread with a spiced mixture of tomato sauce and cheese.", 
                action = {"eat", "hold"}, 
		slot = 9, 
                food = function() return math.random(75,100) end, 
                fimage = "gfx/weiwen/pizza.png", 
                func = {eat, equip}, 
	},

	[6] = {
		name = "Banana", 
		r = 255, g = 255, b = 0, 
		action = {"eat", "hold"}, 
		slot = 9, 
		food = function() return math.random(40,80) end, 
		fimage = "gfx/weiwen/banana.png", 
		func = {eat, equip}, 
	},

	[7] = {
		name = "Cake", 
		r = 255, g = 255, b = 255, 
		action = {"eat", "hold"}, 
		slot = 9, 
		food = function() return 200 end, 
		fimage = "gfx/weiwen/cake.png", 
		func = {eat, equip},
	},
	
	[8] = {
		name = "Orange", 
		r = 255, g = 128, b = 64, 
		action = {"eat", "hold"}, 
		slot = 9, 
		food = function() return math.random(10,30) end, 
		fimage = "gfx/weiwen/circle.png", 
		func = {eat, equip},
	},
	
	[9] = {
		name = "Candy", 
		r = 255, g = 255, b = 255, 
		action = {"eat", "hold"}, 
		slot = 9, 
		food = function() return math.random(5,30) end, 
		fimage = "gfx/weiwen/candy.png", 
		func = {eat, equip},
	},
	
	[10] = {
		name = "Lolipop", 
		r = 255, g = 255, b = 255, 
		action = {"eat", "hold"}, 
		slot = 9, 
		food = function() return math.random(15,45) end, 
		fimage = "gfx/weiwen/lolipop.png", 
		func = {eat, equip},
	},
	
	[11] = {
		name = "Chocolate", 
		r = 255, g = 255, b = 255, 
		desc = "A chocolate, heals 15-30", 
		action = {"eat", "hold"},
		slot = 9,  
		food = function() return math.random(15,30) end, 
		fimage = "gfx/weiwen/chocolate.png", 
		func = {eat, equip},
	},
	
	[12] = {
		name = "Doughtnut", 
		desc = "A simple doughnut that heals 40-100.", 
		r = 255, g = 255, b = 255, 
		action = {"eat", "hold"}, 
		slot = 9, 
		food = function() return math.random(40,100) end, 
		fimage = "gfx/weiwen/doughnut/doughnut.png", 
		func = {eat, equip},
	},
	
	[13] = {
		name = "Doughtnut P", 
		desc = "Heals 40-100, a doughnut with white powder.", 
		r = 255, g = 255, b = 255, 
		action = {"eat", "hold"}, 
		slot = 9, 
		food = function() return math.random(40,100) end, 
		fimage = "gfx/weiwen/doughnut/doughnut_powder.png", 
		func = {eat, equip},
	},
	

	[14] = {
		name = "Doughnut P CH", 
		desc = "Heals 40-100, a doughnut with white powder and brown chocolate.", 
		r = 255, g = 255, b = 255, 
		action = {"eat","hold"}, 
		slot = 9, 
		food = function() return math.random(40,100) end, 
		fimage = "gfx/weiwen/doughnut/doughnut_powder_chocolate.png", 
		func = {eat, equip},
	},


	[15] = {
		name = "Doughnut CH", 
		desc = "Heals 90, a doughnut with brown chocolate.", 
		r = 255, g = 255, b = 255, 
		action = {"eat","hold"}, 
		slot = 9, 
		food = function() return 90 end, 
		fimage = "gfx/weiwen/doughnut/doughnut_chocolate.png", 
		func = {eat, equip},
	},

	[16] = {
		name = "Doughnut CH C", 
		desc = "Heals 100, a doughnut with brown chocolate and white coconout.", 
		r = 255, g = 255, b = 255, 
		action = {"eat","hold"}, 
		slot = 9, 
		food = function() return 100 end, 
		fimage = "gfx/weiwen/doughnut/doughnut_chocolate_coconout.png", 
		func = {eat, equip},
	},

	[17] = {
		name = "Meat", 
		desc = "Heals 30, you may only use it once.", 
		r = 255, g = 255, b = 255, 
		action = {"eat","hold"}, 
		slot = 9, 
		food = function() return 30 end, 
		fimage = "gfx/weiwen/meat.png", 
		func = {eat, equip},
	},
	

	[18] = {
		name = "Big Meat", 
		desc = "Heals 40 hp, you may only use it once.", 
		r = 255, g = 255, b = 255, 
		action = {"eat","hold"}, 
		slot = 9, 
		food = function() return 40 end, 
		fimage = "gfx/weiwen/bigmeat.png", 
		func = {eat, equip},
	},

	[19] = {
		name = "Fish", 
		desc = "You may only use it once.", 
		r = 128, g = 255, b = 255, 
		action = {"eat","hold"}, 
		slot = 9, 
		food = function() return 80 end, 
		fimage = "gfx/weiwen1/fish.png", 
		func = {eat, equip},
	},


	[20] = {
		name = "1K", 
		article = " ",
		desc = "Money.", 
		r = 255, g = 255, b = 255, 
		fimage = "gfx/weiwen/money/4.png",  
		action= {"acquire"}, 
		func = {function(id,itemslot)
					addmoney(id, 1000)
					destroyitem(id, itemslot)
				end
		}, 
	}, 

	[21] = {
		name = "5K", 
		article = " ", 
		desc = "Money.", 
		r = 255, g = 255, b = 255, 
		fimage = "gfx/weiwen/money/5.png", 
		action= {"acquire"}, 
		func = {function(id,itemslot)
					addmoney(id, 5000)
					destroyitem(id, itemslot)
				end
		}, 
	}, 

	[22] = {
		name = "10K", 
		article = " ", 
		desc = "Money.", 
		r = 255, g = 255, b = 255, 
		fimage = "gfx/weiwen/money/6.png",
		action= {"acquire"}, 
		func = {function(id,itemslot)
					addmoney(id, 10000)
					destroyitem(id, itemslot)
				end
		}, 		
	}, 

	[23] = {
		name = "50K", 
		article = " ", 
		desc = "Money, exchange at the bank.", 
		r = 255, g = 255, b = 255,  
		fimage = "gfx/weiwen/money/7.png", 
		action= {"acquire"}, 
		func = {function(id,itemslot)
					addmoney(id, 50000)
					destroyitem(id, itemslot)
				end
		}, 
	}, 

	[24] = {
		name = "100K", 
		article = " ", 
		desc = "Money.", 
		r = 255, g = 255, b = 255, 
		fimage = "gfx/weiwen/money/8.png", 
		action= {"acquire"}, 
		func = {function(id,itemslot)
					addmoney(id, 100000)
					destroyitem(id, itemslot)
				end
		}, 
	}, 

	[25] = {
		name = "500K", 
		article = " ", 
		desc = "Money.", 
		r = 255, g = 255, b = 255, 
		fimage = "gfx/weiwen/money/9.png", 
		action= {"acquire"}, 
		func = {function(id,itemslot)
					addmoney(id, 500000)
					destroyitem(id, itemslot)
				end
		}, 
	}, 

	[26] = {
		name = "1M", 
		article = " ", 
		desc = "Money.", 
		r = 255, g = 255, b = 255, 
		fimage = "gfx/weiwen/money/10.png", 
		action= {"acquire"}, 
		func = {function(id,itemslot)
					addmoney(id, 1000000)
					destroyitem(id, itemslot)
				end
		}, 
	}, 

	[100] = {
		name = "ember rune", 
		desc = "You may only use it once.", 
		r = 128, g = 0, b = 0, 
		action = {"cast","hold"}, 
		slot = 9, 
		fimage = "gfx/weiwen/rune.png", 
		func = {function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " casts a fireball rune.", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 64, 15, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 100 64 255 128 0;")
			parse("effect \"colorsmoke\" " .. pos .. " 75 64 255 0 0")
			destroyitem(id, itemslot, equip)
		end,equip},
	},

	[101] = {
		name = "water gun rune", 
		desc = "You may only use it once.", 
		r = 128, g = 128, b = 255, 
		action = {"cast","hold"}, 
		slot = 9, 
		fimage = "gfx/weiwen/rune.png", 
		func = {function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " casts a waterball rune.", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 64, 15, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 100 64 255 255 255")
			parse("effect \"colorsmoke\" " .. pos .. " 75 64 128 128 255")
			destroyitem(id, itemslot, equip)
		end,equip},
	},

	[102] = {
		name = "healing rune", 
		desc = "You may only use it once.", 
		r = 128, g = 255, b = 255, 
		action = {"cast","hold"}, 
		slot = 9, 
		fimage = "gfx/weiwen/rune.png", 
		func = {function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " casts a healing rune.", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 32, -30, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 128 255 255")
			radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
			destroyitem(id, itemslot, equip)
		end,equip},
	},

	[103] = {
		name = "thundershock rune", 
		desc = "An electrical attack that may paralyze the foe.",  
		r = 255, g = 255, b = 0, 
		action = {"cast","hold"}, 
		slot = 9, 
		fimage = "gfx/weiwen/rune.png", 
		func = {function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " casts a thundershock rune.", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 64, 15, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 100 64 255 255 0")
			parse("effect \"colorsmoke\" " .. pos .. " 75 64 255 255 255")
			destroyitem(id, itemslot, equip)
		end,equip},
	},

	[104] = {
		name = "flamethrower rune", 
		desc = "You may only use it once.", 
		r = 185, g = 25, b = 25, 
		action = {"cast","hold"}, 
		slot = 9, 
		fimage = "gfx/weiwen/rune.png", 
		func = {function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " casts a firewave rune.", player(id,"x"), player(id,"y"))
			parse("equip " .. id .. " 46")
			parse("setweapon " .. id .. " 46")
			addtimer(1000, parse, "strip " .. id .. " 46")
			destroyitem(id, itemslot, equip)
		end,equip},
	},

	[105] = {
		name = "teleport rune", 
		desc = "You may only use it once.", 
		r = 255, g = 255, b = 255, 
		action = {"cast","hold"}, 
		slot = 9, 
		fimage = "gfx/weiwen/rune.png", 
		func = {function(id, itemslot, itemid, equip)
			radiusmsg(player(id,"name") .. " is casting a teleport rune.", player(id,"x"), player(id,"y"))
			addtimer(1500, ITEMS[105].teleport, id, player(id, 'health'), itemslot, equip)
		end,equip}, 
		teleport = function(id, health, itemslot, equip)
			if player(id, 'health') == health then
				radiusmsg(player(id,"name") .. " completed casting a teleport rune.", player(id,"x"), player(id,"y"))
				parse("effect \"colorsmoke\" " .. player(id,"x") .. " " .. player(id,"y") .. " 5 5 255 255 255")
				local pos = PLAYERS[id].Spawn[1] .. " " .. PLAYERS[id].Spawn[2]
				parse("effect \"colorsmoke\" " .. pos .. " 5 5 255 255 255")
				parse("setpos " .. id .. " " .. pos)
				radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
				destroyitem(id, itemslot, equip)
			else
				radiusmsg(player(id,"name") .. " failed to cast a teleport rune.", player(id,"x"), player(id,"y"))
			end
		end, 
	},

	[106] = {
		name = "poison fog rune", 
		desc = "You may only use it once.", 
		r = 128, g = 128, b = 0, 
		action = {"cast","hold"}, 
		slot = 9, 
		fimage = "gfx/weiwen/rune.png", 
		func = {function(id, itemslot, itemid, equip)
			radiusmsg(player(id,"name") .. " casts a poison fog rune.", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 64, 15, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 100 96 128 128 0")
			destroyitem(id, itemslot, equip)
		end,equip},
	},
	
	[107] = {
		name = "meteor storm rune", 
		desc = "You may only use it once.", 
		r = 255, g = 255, b = 255, 
		action = {"cast","hold"}, 
		slot = 9, 
		fimage = "gfx/weiwen/meteor_rune.png", 
		func = {function(id, itemslot, itemid, equip)
			local range,dmg,erange,rept,gr,xx,yy = 300,25,50,math.random(5,10),0,player(id,"x"),player(id,"y")
			radiusmsg(player(id,"name") .. " casts a meteor storm rune.", xx, yy)
			repeat
				xx,yy=player(id,"x"),player(id,"y")
				xx=xx+math.random(1,range)-math.random(1,range)
				yy=yy+math.random(1,range)-math.random(1,range)
				explosion(xx, yy, erange, dmg, id)
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 255 0 0")
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 127 127 0")
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 255 225 0")
				gr = gr + 1
			until gr >= rept
			destroyitem(id, itemslot, equip)
		end,equip},
	},

	[108] = {
		name = "Leather Helmet |1|", 
		desc = "Protect yourself from headshots!", 
		r = 128, g = 64, b = 0, 
		action = "equip", 
		slot = 1, 
		eimage = "gfx/weiwen/helmet.png", 
		fimage = "gfx/weiwen/helmet.png", 
		def = 0.05, 
		speed = -1,
		func = equip,
	},

	[109] = {
		name = "Leather Torso |1|", 
		desc = "A few holes here and there, but still usable.", 
		r = 128, g = 64, b = 0, 
		action = "equip", 
		slot = 2, 
		eimage = "gfx/weiwen/armour.png", 
		fimage = "gfx/weiwen/farmour.png", 
		def = 0.1, 
		speed = -1,
		func = equip,
	},

	[110] = {
		name = "Leather Legs |1|", 
		plural = "pairs of leather legs", 
		article = "a pair of", 
		desc = "A few holes here and there, but still usable.", 
		r = 128, g = 64, b = 0, 
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen/legs.png", 
		def = 0.07, 
		speed = 1,
		func = equip,
	},

	[111] = {
		name = "Leather Boots |1|", 
		plural = "pairs of leather boots", 
		article = "a pair of", 
		desc = "Waterproof.", 
		r = 128, g = 64, b = 0, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/boots.png",  
		speed = 2, 
		func = equip,
	},

	[112] = {
		name = "Wood Sword |1|", 
		desc = "Mostly used for training.", 
		r = 128, g = 64, b = 0, 
		action = "equip", 
		slot = 3, 
		eimage = "gfx/weiwen/sword.png", 
		fimage = "gfx/weiwen/sword.png", 
		offsetx = 6,
		offsety = 17,
		equip = 69,
		atk = 0.25, 
		speed = -1, 
		func = equip,
	},

	[113] = {
		name = "Wood Shield |1|", 
		desc = "Mostly used for training.", 
		r = 128, g = 64, b = 0, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/shield.png", 
		fimage = "gfx/weiwen/fshield.png", 
		equip = 41,
		def = 0.2, 
		speed = -2, 
		func = equip,
	},

	[114] = {
		name = "Wood Club |1|", 
		desc = "Now you can be a caveman too!", 
		r = 128, g = 64, b = 0, 
		action = "equip", 
		slot = 3, 
		eimage = "gfx/weiwen/club.png", 
		fimage = "gfx/weiwen/club.png", 
		offsety = 14,
		equip = 78,
		atk = 0.35, 
		speed = -2, 
		func = equip,
	},

	[115] = {
		name = "Wood Crossbow |1|", 
		desc = "It requires you to hold it with two hands.", 
		r = 128, g = 64, b = 0, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/bow.png", 
		fimage = "gfx/weiwen/bow.png", 
		offsety = 9,
		equip = 34,
		atk = 0.1, 
		speed = -2.5, 
		func = equip,
	},

	[116] = { 
                name = "Stone Crossbow |5|", 
                desc = "It requires you to hold it with two hands.", 
		r = 128, g = 128, b = 128,  
                action = "equip", 
                slot = 3, 
                twohand = true, 
                eimage = "gfx/weiwen/bow.png", 
                fimage = "gfx/weiwen/bow.png", 
                offsety = 9, 
                equip = 34, 
                atk = 0.2, 
                speed = 1.5, 
                level = 5 , 
                func = equip, 
	}, 

	[117] = {
		name = "Stone Helm |5|", 
		r = 128, g = 128, b = 128, 
		action = "equip", 
		slot = 1, 
		eimage = "gfx/weiwen/helmet.png", 
		fimage = "gfx/weiwen/helmet.png", 
		def = 0.1, 
		speed = -1.5,
		level = 5, 
		func = equip,
	},

	[118] = {
		name = "Stone Armour |5|", 
		r = 128, g = 128, b = 128,
		action = "equip", 
		slot = 2, 
		eimage = "gfx/weiwen/armour.png", 
		fimage = "gfx/weiwen/farmour.png", 
		def = 0.2, 
		speed = -1.5,
		level = 5, 
		func = equip,
	},

	[119] = {
		name = "Stone Leggins |5|", 
		plural = "pairs of iron leggings", 
		article = "a pair of", 
		r = 128, g = 128, b = 128,
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen/legs.png", 
		def = 0.15, 
		speed = -0.5,
		level = 5, 
		func = equip,
	},

	[120] = {
		name = "Stone Boots |5|", 
		plural = "pairs of iron boots", 
		article = "a pair of", 
		r = 128, g = 128, b = 128,
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/boots.png", 
		speed = 0.5, 
		level = 5, 
		func = equip,
	},

	[121] = {
		name = "Stone Sword |5|", 
		r = 128, g = 128, b = 128,
		action = "equip", 
		slot = 3, 
		eimage = "gfx/weiwen/sword.png", 
		fimage = "gfx/weiwen/sword.png", 
		offsetx = 6,
		offsety = 17,
		equip = 69,
		atk = 0.5, 
		speed = -2, 
		level = 5, 
		func = equip,
	},

	[122] = {
		name = "Stone Shield |5|", 
		r = 128, g = 128, b = 128,
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/shield.png", 
		fimage = "gfx/weiwen/fshield.png", 
		equip = 41,
		def = 0.4, 
		speed = -3, 
		level = 5, 
		func = equip,
	},

	[123] = {
		name = "Stone Mace |5|", 
		r = 128, g = 128, b = 128,
		action = "equip", 
		slot = 3, 
		eimage = "gfx/weiwen/mace.png", 
		fimage = "gfx/weiwen/mace.png", 
		offsetx = 4, 
		offsety = 20,
		equip = 78,
		atk = 0.7, 
		speed = -3, 
		level = 5, 
		func = equip,
	},

	[124] = { 
		name = "Steel Sword |15|", 
                r = 198, g = 198, b = 198, 
                action = "equip", 
                slot = 3, 
                eimage = "gfx/weiwen/sword.png", 
                fimage = "gfx/weiwen/sword.png", 
                offsetx = 6, 
                offsety = 17, 
                equip = 69, 
                atk = 2.0, 
                speed = -1, 
                level = 15, 
                func = equip, 
	},

	[125] = { 
		name = "Steel Crossbow |15|", 
                r = 198, g = 198, b = 198, 
                action = "equip", 
                slot = 3, 
                eimage = "gfx/weiwen/bow.png", 
                fimage = "gfx/weiwen/bow.png", 
                offsetx = 6, 
                offsety = 17, 
                equip = 34, 
                atk = 0.8, 
                speed = -1, 
                level = 15, 
                func = equip, 
	},

	[126] = { 
		name = "Steel Legs |15|", 
                r = 198, g = 198, b = 198, 
                action = "equip", 
                slot = 5, 
                fimage = "gfx/weiwen/legs.png", 
                offsetx = 6, 
                offsety = 17, 
                def = 0.6, 
                level = 15, 
                func = equip, 
	},

	[127] = { 
		name = "Steel Helm |15|", 
                r = 198, g = 198, b = 198, 
                action = "equip", 
                slot = 1, 
                eimage = "gfx/weiwen/helmet.png", 
                fimage = "gfx/weiwen/helmet.png", 
                offsetx = 6, 
                offsety = 17, 
                def = 0.4, 
                level = 15, 
                func = equip, 
	},

	[128] = { 
		name = "Steel Armour |15|", 
                r = 198, g = 198, b = 198, 
                action = "equip", 
                slot = 2, 
                eimage = "gfx/weiwen/armour.png", 
                fimage = "gfx/weiwen/farmour.png", 
                offsetx = 6, 
                offsety = 17, 
                def = 0.8, 
                level = 15, 
                func = equip, 
	},

	[129] = { 
		name = "Steel Boots |15|", 
                r = 198, g = 198, b = 198, 
                action = "equip", 
                slot = 6, 
                eimage = "gfx/weiwen/sword.png", 
                fimage = "gfx/weiwen/sword.png", 
                offsetx = 6, 
                offsety = 17, 
                speed = -1, 
                level = 15, 
                func = equip, 
	},

	[232] = { 
		name = "Steel Shield |15|", 
                r = 198, g = 198, b = 198, 
                action = "equip", 
                slot = 4, 
                eimage = "gfx/weiwen/shield.png", 
                fimage = "gfx/weiwen/fshield.png", 
                offsetx = 6, 
                offsety = 17, 
                def = 1.6, 
		equip = 41,
                speed = -1, 
                level = 15, 
                func = equip, 
	},

	[130] = {
		name = "Bronze Sword |10|", 
		r = 200, g = 100, b = 0, 
		action = "equip", 
		slot = 3, 
		eimage = "gfx/weiwen/sword.png", 
		fimage = "gfx/weiwen/sword.png", 
		offsetx = 6,
		offsety = 17,
		equip = 69,
		atk = 1.0, 
		speed = -1.5, 
		level = 10, 
		func = equip,
	},

	[131] = {
		name = "Bronze Leggings |10|", 
		r = 200, g = 100, b = 0, 
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen/legs.png", 
		offsetx = 6,
		offsety = 17,
		equip = 69,
		def = 0.3, 
		level = 10, 
		func = equip,
	},

	[132] = {
		name = "Bronze Boots |10|", 
		r = 200, g = 100, b = 0, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/boots.png", 
		offsetx = 6,
		offsety = 17,
		speed = 1.5, 
		level = 10, 
		func = equip,
	},

	[133] = {
		name = "Bronze Helm |10|", 
		r = 200, g = 100, b = 0, 
		action = "equip", 
		slot = 1, 
		eimage = "gfx/weiwen/helmet.png", 
		fimage = "gfx/weiwen/helmet.png", 
		offsetx = 1,
		offsety = 17,
		def = 0.2, 
		level = 10, 
		func = equip,
	},

	[134] = {
		name = "Bronze Armour |10|", 
		r = 200, g = 100, b = 0, 
		action = "equip", 
		slot = 2, 
                eimage = "gfx/weiwen/armour.png", 
                fimage = "gfx/weiwen/farmour.png",  
		offsetx = 6,
		offsety = 17,
		def = 0.4, 
		speed = -1.5, 
		level = 10, 
		func = equip,
	},

	[135] = {
		name = "Bronze Shield |10|", 
		r = 200, g = 100, b = 0, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/shield.png", 
		fimage = "gfx/weiwen/fshield.png", 
		equip = 41,
		def = 0.8, 
		level = 10, 
		func = equip,
	},

	[136] = {
		name = "Bronze Crossbow |10|", 
		r = 200, g = 100, b = 0, 
		action = "equip", 
		slot = 3, 
		eimage = "gfx/weiwen/bow.png", 
		fimage = "gfx/weiwen/bow.png", 
		offsetx = 4, 
		offsety = 20,
		equip = 34,
		atk = 0.4, 
		speed = -3, 
		level = 10, 
		func = equip,
	},

	[137] = {
		name = "Dragon Armour |20|", 
		desc = "Protect from swords,crossbows and dragon fire.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		level = 20,
		slot = 2, 
		eimage = "gfx/weiwen/dragon_armor.png", 
		fimage = "gfx/weiwen/dragon_farmour.png", 
		def = 1.6, 
		speed = -1,
		func = equip,
	},

	[138] = {
		name = "Dragon Legs |20|", 
		plural = "pairs of dragon legs", 
		article = "a pair of", 
		desc = "A very light and strong legs.", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		level = 20,
		fimage = "gfx/weiwen/dragon_legs.png", 
		def = 1.2, 
		func = equip,
	},

	[139] = {
		name = "Dragon Boots |20|", 
		plural = "pairs of dragon boots", 
		article = "a pair of", 
		desc = "Very light boots.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		level = 20,
		slot = 6, 
		fimage = "gfx/weiwen/dragon_boots.png",  
		speed = 2, 
		func = equip,
	},

	[140] = {
		name = "Dragon Sword |20|", 
		desc = "I can kill dragon with it.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		level = 20,
		eimage = "gfx/weiwen/dragon_sword.png", 
		fimage = "gfx/weiwen/dragon_sword.png", 
		offsetx = 6,
		offsety = 17,
		equip = 69,
		atk = 1.4, 
		speed = -1, 
		func = equip,
	},

	[141] = {
		name = "Dragon Shield |20|", 
		desc = "It's procet from dragon fire.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/dragon_shield.png", 
		fimage = "gfx/weiwen/dragon_fshield.png", 
		equip = 41,
		def = 3.2, 
		speed = -1, 
		level = 20,
		func = equip,
	},

	[142] = {
		name = "Dragon Mace |20|", 
		desc = "dragon mace can make big hole in head!", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		eimage = "gfx/weiwen/dragon_mace.png", 
		fimage = "gfx/weiwen/dragon_mace.png", 
		offsety = 14,
		equip = 78,
		level = 20,
		atk = 1.9, 
		speed = -1, 
		func = equip,
	},

	[143] = {
		name = "Dragon Bow |20|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/dragon_bow.png", 
		fimage = "gfx/weiwen/dragon_bow.png", 
		offsety = 9,
		equip = 6,
		level = 20,
		atk = 1.6, 
		speed = -1, 
		func = equip,
	},

	[233] = {
		name = "Dragon Tooth |20|", 
		desc = "The tooth of a powerfull dragon, it is sayd to have magical properties.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 8, 
		twohand = false, 
		fimage = "gfx/weiwen/dragon_tooth.png", 
		offsety = 9,
		def = 2, 
		level = 20,
		speed = 3, 
		func = equip,
	},
	
	[144] = {
		name = "Dragon Wings |20|", 
		desc = "Very light and speed adding wings.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		level = 20,
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/dragon_wings.png",  
		eimage = "gfx/weiwen/dragon_wings.png",  
		speed = 15, 
		func = equip,
	},
	
		[238] = {
		name = "Dragon Helm |20|", 
		desc = "Protect from swords,crossbows and dragon fire.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1, 
		eimage = "gfx/weiwen/dragon_helm.png", 
		fimage = "gfx/weiwen/dragon_helm.png", 
		def = 0.8, 
		level = 20,
		func = equip,
	},

	[145] = {
		name = "Nature Boots |25|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/berserker_boots.png",  
		speed = 3, 
		level = 25,
		func = equip,
	},
	
	[146] = {
		name = "Nature Helm |25|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1, 
		fimage = "gfx/weiwen/berserker_helm.png", 
		eimage = "gfx/weiwen/berserker_helm.png", 		
		def = 1.2, 
		speed = 3, 
		func = equip,
		level = 25,
	},
	
	[147] = {
		name = "Nature Ring |25|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 8, 
		fimage = "gfx/weiwen/berserker_ring.png",  
		def = 3, 
		speed = 4, 
		func = equip,
		level = 25,
	},
	
	[148] = {
		name = "Nature Mace |25|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		fimage = "gfx/weiwen/berserker_mace.png",  
		eimage = "gfx/weiwen/berserker_mace.png",  
		offsety = 14,
		speed = 0, 
		level = 25,
		atk = 10, 
		func = equip,
	},

	 [149] = {
		name = "Nature Armour |25|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2,
		level = 25,
		fimage = "gfx/weiwen/armour..png",  
		eimage = "gfx/weiwen/armour..png",  
		def = 2.4, 
		level = 25,
		func = equip,
	},
	
		 [239] = {
		name = "Nature Legs |25|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2,
		level = 25,
		fimage = "gfx/weiwen/berserker_legs.png",  
		def = 1.8, 
		level = 25,
		func = equip,
	},

	[150] = {
		name = "Nature Bow |25|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/berserker_bow.png", 
		fimage = "gfx/weiwen/berserker_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 3, 
		level = 25,
		speed = -0.9, 
		func = equip,
	},

	[234] = {
		name = "Nature Wings |25|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		level = 25,
		ground = true, 
		water = true, 
		eimage = "gfx/weiwen/horsess.png", 
		fimage = "gfx/weiwen/horsess.png", 
		speed = 17, 
		level = 25, 
		func = equip,
	},


        	[151] = { 
                name = "Magic Helm |30|", 
                desc = "It has a weird blue glow.", 
                r = 64, g = 64, b = 250, 
                action = "equip", 
                slot = 1, 
                twohand = true, 
                eimage = "gfx/weiwen/helmet.png", 
                fimage = "gfx/weiwen/helmet.png", 
                offsety = 9, 
                def = 1.25, 
                speed = 1.25, 
                level = 30, 
                func = equip, 
	}, 

        	[152] = { 
                name = "Magic Shield |30|", 
                desc = "It has a weird blue glow.", 
                r = 64, g = 64, b = 250, 
                action = "equip", 
                slot = 4, 
                twohand = true, 
                eimage = "gfx/weiwen/shield.png", 
                fimage = "gfx/weiwen/fshield.png", 
                offsety = 9, 
                equip = 41, 
                def = 3.0, 
                level = 30 , 
                func = equip, 
	}, 

        	[153] = { 
                name = "Magic Leggings |30|", 
                desc = "It has a weird blue glow.", 
                r = 64, g = 64, b = 250, 
                action = "equip", 
                slot = 5, 
                twohand = true, 
                fimage = "gfx/weiwen/legs.png", 
                offsety = 9, 
                def = 1.5, 
                speed = 1.5, 
                level = 30 , 
                func = equip, 
	}, 

        	[154] = { 
                name = "Magic Armour |30|", 
                desc = "It has a weird blue glow.", 
                r = 64, g = 64, b = 250, 
                action = "equip", 
                slot = 2, 
                twohand = true, 
                eimage = "gfx/weiwen/armour.png", 
                fimage = "gfx/weiwen/farmour.png", 
                offsety = 9, 
                def = 2.5, 
                speed = 1.5, 
                level = 30 , 
                func = equip, 
	}, 

        	[155] = { 
                name = "Magic Boots |30|", 
                desc = "It has a weird blue glow.", 
                r = 64, g = 64, b = 250, 
                action = "equip", 
                slot = 6, 
                twohand = true, 
                fimage = "gfx/weiwen/boots.png", 
                offsety = 9, 
                speed = 3.5, 
                level = 30 , 
                func = equip, 
	}, 

        	[156] = { 
                name = "Magic Bow |30|", 
                desc = "It requires you to hold it with two hands.", 
                r = 64, g = 64, b = 250, 
                action = "equip", 
                slot = 3, 
                twohand = true, 
                eimage = "gfx/weiwen/bow.png", 
                fimage = "gfx/weiwen/bow.png", 
                offsety = 9, 
                equip = 6, 
                atk = 7, 
                speed = 1.5, 
                level = 30 , 
                func = equip, 
	}, 

        	[235] = { 
                name = "Magic Pendant |30|", 
                desc = "It seems to have some magical properties.", 
                r = 64, g = 64, b = 250, 
                action = "equip", 
                slot = 8, 
                twohand = true, 
                fimage = "gfx/weiwen/pendant.png", 
                offsety = 9, 
                speed = 5, 
				def= 4, 
                speed = 1.5, 
                level = 30 , 
                func = equip, 
	}, 

        	[236] = { 
                name = "Magic Wings |30|", 
                desc = "They have a strange looking glow.", 
                r = 64, g = 64, b = 250, 
                action = "equip", 
                slot = 7, 
                twohand = true, 
                eimage = "gfx/weiwen/wings3.png", 
                fimage = "gfx/weiwen/wings3.png", 
				ground = true, 
				water = true, 
                speed = 19, 
                level = 30 , 
                func = equip, 
	}, 
           
	[157] = { 
                name = "Magic Mace |30|", 
                r = 40, g = 50, b = 250, 
                action = "equip", 
                slot = 3, 
                eimage = "gfx/weiwen/mace.png", 
                fimage = "gfx/weiwen/mace.png", 
                offsetx = 4, 
                offsety = 20, 
                equip = 78, 
                atk = 2.7, 
                speed = 1, 
                level = 30, 
                func = equip, 
	}, 

	[158] = {
		name = "Ice Helmet |40|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1, 
		eimage = "gfx/weiwen/ice_helm.png", 
		fimage = "gfx/weiwen/ice_helm.png", 
		def = 2.25, 
		level = 40,
		speed = 2,
		func = equip,
	},

	[159] = {
		name = "Ice Armour |40|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2, 
		level = 40,
		eimage = "gfx/weiwen/ice_armor.png", 
		fimage = "gfx/weiwen/ice_farmour.png", 
		def = 4.5, 
		speed = 2,
		func = equip,
	},

	[160] = {
		name = "Ice Legs |40|", 
		plural = "pairs of ice legs", 
		article = "a pair of", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		level = 40,
		fimage = "gfx/weiwen/ice_legs.png", 
		def = 3.75, 
		speed = 2,
		func = equip,
	},

	[161] = {
		name = "Ice Boots |40|", 
		plural = "pairs of ice boots", 
		article = "a pair of", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		level = 40,
		slot = 6, 
		fimage = "gfx/weiwen/ice_boots.png",  
		speed = 5, 
		func = equip,
	},

	[162] = {
		name = "Ice Sword |40|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		eimage = "gfx/weiwen/ice_sword.png", 
		fimage = "gfx/weiwen/ice_sword.png", 
		offsetx = 6,
		level = 40,
		offsety = 17,
		equip = 69,
		atk = 1.4, 
		speed = 0, 
		func = equip,
	},

	[163] = {
		name = "Ice Shield |40|", 
		desc = "It's protects from ice fire.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		level = 40,
		eimage = "gfx/weiwen/ice_shield.png", 
		fimage = "gfx/weiwen/ice_fshield.png", 
		equip = 41,
		def = 5.0, 
		speed = 2, 
		func = equip,
	},

	[164] = {
		name = "Ice Mace |40|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		level = 40,
		eimage = "gfx/weiwen/ice_mace.png", 
		fimage = "gfx/weiwen/ice_mace.png", 
		offsety = 14,
		equip = 78,
		atk = 6.5, 
		speed = 0, 
		func = equip,
	},
	
	[165] = {
		name = "Ice Bow |40|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		level = 40,
		eimage = "gfx/weiwen/ice_bow.png", 
		fimage = "gfx/weiwen/ice_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 12, 
		speed = 2, 
		func = equip,
	},

	[237] = {
		name = "Ice Shard |40|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 8, 
		fimage = "gfx/weiwen/ice_shard.png", 
		offsety = 9,
		def = 6, 
		speed = 7, 
		level = 40,
		func = equip,
	},

	[166] = {
		name = "Ice Wings |40|", 
		desc = "Very light and adding speed wings.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		ground = true, 
		water = true, 
		level = 40,
		fimage = "gfx/weiwen/crystal_wings.png",  
		eimage = "gfx/weiwen/crystal_wings.png",  
		speed = 21, 
		func = equip,
	},

	[167] = {
		name = "Water Boots |50|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6,
		fimage = "gfx/weiwen/water_boots.png",  
		speed = 8,
		level = 50,
		func = equip,
	},

	[168] = {
		name = "Water Helm |50|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen/water_helm.png",  
		eimage = "gfx/weiwen/water_helm.png",  
		def = 3.25, 
		speed = 4,
		level = 50,
		func = equip,
	},

	[169] = {
		name = "Water Legs |50|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 5,
		fimage = "gfx/weiwen/water_legs.png",  
		def = 4.3, 
		speed = 4,
		level = 50,
		func = equip,
	},

	[170] = {
		name = "Water Bow |50|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		level = 50, 
		eimage = "gfx/weiwen/water_bow.png", 
		fimage = "gfx/weiwen/water_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 25.0, 
		speed = 4, 
		func = equip,
	},

	[171] = {
		name = "Water Armour |50|", 
		desc = "You can hear the ocean.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2, 
		level = 50, 
		eimage = "gfx/weiwen/water_armour.png", 
		fimage = "gfx/weiwen/water_farmour.png", 
		offsety = 9,
		def = 6.5, 
		speed = 4, 
		func = equip,
	},
	
		[172] = {
		name = "Water Wings |50|", 
		desc = "You can hear the ocean.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		level = 50, 
		eimage = "gfx/weiwen/angel.png", 
		fimage = "gfx/weiwen/angel.png", 
		speed = 23, 
		ground = true, 
		water = true, 
		func = equip,
	},


	[173] = {
		name = "Water Shield |50|", 
		desc = "It protects from getting wet.", 
		r = 70, g = 70, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/ice_shield.png", 
		fimage = "gfx/weiwen/ice_fshield.png", 
		equip = 41,
		def = 1.0, 
		speed = 3, 
		func = equip,
	},
	

		[174] = {
		name = "Fairy Boots |60|", 
		desc = "Makes you run as fast as a fairy.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6,
		fimage = "gfx/weiwen/sunflare_boots.png",  
		speed = 9,
		level = 60,
		func = equip,
	},

	[175] = {
		name = "Fairy Helm |60|", 
		desc = "Made out of a fairy head.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen/sunflare_helm.png",  
		eimage = "gfx/weiwen/sunflare_helm.png",  
		def = 3.75, 
		speed = 5,
		level = 60,
		func = equip,
	},

	[176] = {
		name = "Fairy Legs |60|",
		desc = "Used real fairy skin maknig theese fashioned leggings!", 		
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 5,
		fimage = "gfx/weiwen/sunflare_legs.png",  
		def = 5.0, 
		speed = 5,
		level = 60,
		func = equip,
	},

	[177] = {
		name = "Fairy Bow |60|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		level = 60, 
		eimage = "gfx/weiwen/sunflare_bow.png", 
		fimage = "gfx/weiwen/sunflare_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 36, 
		speed = 5, 
		func = equip,
	},

	[178] = {
		name = "Fairy Armour |60|", 
		desc = "Made with a farys chest.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2, 
		level = 60, 
		eimage = "gfx/weiwen/sunflare_armour.png", 
		fimage = "gfx/weiwen/sunflare_farmour.png", 
		offsety = 9,
		def = 7.5, 
		speed = 5, 
		func = equip,
	},
	
		[179] = {
		name = "Fairy Wings |60|", 
		desc = "Disgusting, tou took the fairys wings!", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		level = 60, 
		eimage = "gfx/weiwen/phoenix_wing.png", 
		fimage = "gfx/weiwen/phoenix_wing.png", 
		speed = 25, 
		ground = true, 
		water = true, 
		func = equip,
	},


	[180] = {
		name = "Fairy Shield |60|", 
		desc = "Made from the hardest part of a fairy, its heart.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		level = 60, 
		eimage = "gfx/weiwen/fairy_shield.png", 
		fimage = "gfx/weiwen/fairy_fshield.png", 
		equip = 41,
		def = 8.0, 
		speed = 4, 
		func = equip,
	},
	
	
	[181] = {
		name = "City scroll", 
		desc = "Teleports you back to the city.", 
		r = 255, g = 255, b = 255, 
		action = "Use", 
		fimage = "gfx/weiwen/scroll.png", 
		func = { function(id, itemslot, itemid, equip)
				radiusmsg(player(id,"name") .. " used a city scroll.", player(id,"x"), player(id,"y"))
				parse("effect \"colorsmoke\" " .. player(id,"x") .. " " .. player(id,"y") .. " 5 5 255 255 255")
				local pos = PLAYERS[id].Spawn[1] .. " " .. PLAYERS[id].Spawn[2]
				parse("effect \"colorsmoke\" " .. pos .. " 5 5 255 255 255")
				parse("setpos " .. id .. " " .. pos)
				radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
				destroyitem(id, itemslot, equip)
		
		end },
	},

	[182] = {
		name = "Admin Bow |1|", 
		desc = "Only for admins!", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/gron_bow.png", 
		fimage = "gfx/weiwen/gron_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 100000, 
		def= 100000,
		func = equip,
	},
	
		[183] = {
		name = "Admin Wings |1|", 
		desc = "Only for admins!", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		hp = 150,
		eimage = "gfx/weiwen/fallenangelwings.png", 
		fimage = "gfx/weiwen/fallenangelwings.png", 
		offsetx = 61, 
		offsety = 25,
		ground = true, 
		water = true, 
		func = equip,
	},
	
		[184] = {
		name = "Magma Boots |70|", 
		desc = "This burn you so much they make you run like hell.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6,
		fimage = "gfx/weiwen/magma_boots.png",  
		speed = 10,
		level = 70,
		func = equip,
	},

	[185] = {
		name = "Magma Helm |70|", 
		desc = "This will burn your hair.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen/magma_helm.png",  
		eimage = "gfx/weiwen/magma_helm.png",  
		def = 5, 
		speed = 5.5,
		level = 70,
		func = equip,
	},

	[186] = {
		name = "Magma Legs |70|",
		desc = "Your pants will be on fire!", 		
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 5,
		fimage = "gfx/weiwen/magma_legs.png",  
		def = 9.0, 
		speed = 5.5,
		level = 70,
		func = equip,
	},

	[187] = {
		name = "Magma Bow |70|", 
		desc = "How can you grab it without having serius burns?", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		level = 70, 
		eimage = "gfx/weiwen/magma_bow.png", 
		fimage = "gfx/weiwen/magma_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 70, 
		speed = 6, 
		func = equip,
	},

	[188] = {
		name = "Magma Armour |70|", 
		desc = "Lucky im not you wearing this.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2, 
		level = 70, 
		eimage = "gfx/weiwen/magma_armour.png", 
		fimage = "gfx/weiwen/magma_farmour.png", 
		offsety = 9,
		def = 14.0, 
		speed = 5.5, 
		func = equip,
	},
	
		[189] = {
		name = "Magma Wings |70|", 
		desc = "Theese stick to your back with burning lava, ouch!", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		level = 70, 
		eimage = "gfx/weiwen/magma_wings.png", 
		fimage = "gfx/weiwen/magma_wings.png", 
		speed = 27, 
		ground = true, 
		water = true, 
		func = equip,
	},


	[190] = {
		name = "Magma Shield |70|", 
		desc = "Protects from lava.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		level = 70, 
		eimage = "gfx/weiwen/magma_shield.png", 
		fimage = "gfx/weiwen/magma_fshield.png", 
		equip = 41,
		def = 15.0, 
		speed = 4.5, 
		func = equip,
	},
	
		[191] = {
		name = "Robot Boots |80|", 
		desc = "Mechanical legs, you will run real fast!", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6,
		fimage = "gfx/weiwen/robot_boots.png",  
		speed = 11,
		def = 1.0,
		level = 80,
		func = equip,
	},

	[192] = {
		name = "Robot Helm |80|", 
		desc = "I am your father.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen/robot_helm.png",  
		eimage = "gfx/weiwen/robot_helm.png",  
		def = 9.0, 
		speed = 6,
		level = 80,
		func = equip,
	},

	[193] = {
		name = "Robot Legs |80|",
		desc = "Mechanical pants!", 		
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 5,
		fimage = "gfx/weiwen/robot_legs.png",  
		def = 16.0, 
		speed = 6,
		level = 80,
		func = equip,
	},

	[194] = {
		name = "Robot Bow |80|", 
		desc = "Why would a robot use a bow?", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		level = 80, 
		eimage = "gfx/weiwen/robot_bow.png", 
		fimage = "gfx/weiwen/robot_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 125, 
		speed = 6.5, 
		func = equip,
	},

	[195] = {
		name = "Robot Armour |80|", 
		desc = "You will look like a clone from star wars! But not really...", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2, 
		level = 80, 
		eimage = "gfx/weiwen/robot_armour.png", 
		fimage = "gfx/weiwen/robot_farmour.png", 
		offsety = 9,
		def = 14.0, 
		speed = 5.5, 
		func = equip,
	},
	
		[196] = {
		name = "Robot Wings |80|", 
		desc = "Theese have a lot of spikes to atach to your back, ouch!", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		level = 80, 
		eimage = "gfx/weiwen/robot_wings.png", 
		fimage = "gfx/weiwen/robot_wings.png", 
		speed = 28, 
		ground = true, 
		water = true, 
		func = equip,
	},


	[197] = {
		name = "Robot Shield |80|", 
		desc = "High tec shield!", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		level = 80, 
		eimage = "gfx/weiwen/robot_shield.png", 
		fimage = "gfx/weiwen/robot_fshield.png", 
		equip = 41,
		def = 28.0, 
		speed = 5, 
		func = equip,
	},
	
	[240] = {
		name = "Phoenix Crossbow |90|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/phoenix_bow.png",
		fimage = "gfx/weiwen/phoenix_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 400.0, 
		speed = 0, 
		level = 90,
		func = equip,
	},
		
		[241] = {
		name = "Phoenix Armour |90|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2, 
		eimage = "gfx/weiwen/phoenix_armor.png", 
		fimage = "gfx/weiwen/phoenix_armor1.png", 
		def = 50.0, 
		speed = 6.4,
		level = 90,
		func = equip,
	},
	
		[242] = {
		name = "Phoenix Helm |90|",
		desc = "Made out of a phoenix burning skin.",
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1, 
		eimage = "gfx/weiwen/phoenix_helm.png", 
		fimage = "gfx/weiwen/phoenix_helm.png", 
		def = 33.0, 
		speed = 6.9,
		level = 90, 
		func = equip,
	},
	
		[243] = {
		name = "Phoenix Wings |90|", 
		desc = "How do you equip this?", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/phoenix2_wing.png",  
		eimage = "gfx/weiwen/phoenix2_wing.png",  
		speed = 29,
		def = 5.0,
		atk = 5.0,
		level = 90, 
		func = equip,	
	},
	
	[244] = {
		name = "Phoenix Legs |90|",
		desc = "Made out of phoenix skin.", 		
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 5,
		fimage = "gfx/weiwen/phoenix_legs.png",  
		def = 30.0, 
		speed = 6.4,
		level = 90,
		func = equip,
	},
	
		[245] = {
		name = "Phoenix Boots |90|", 
		desc = "This burn you so much they make you run like hell.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6,
		fimage = "gfx/weiwen/phoenix_boots.png",  
		speed = 11.8,
		def = 2.0,
		level = 90,
		func = equip,
	},
	
	[246] = {
		name = "Phoenix Shield |90|", 
		desc = "Protects from.. phoenixs?.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		level = 90, 
		eimage = "gfx/weiwen/phoenix_shield.png", 
		fimage = "gfx/weiwen/phoenix_fshield.png", 
		equip = 41,
		def = 56.0, 
		speed = 5.4, 
		func = equip,
	},
	
	[247] = {
		name = "Wizard Helm |100|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1, 
		eimage = "gfx/weiwen1/wizard_helmet.png", 
		fimage = "gfx/weiwen1/wizard_helmet.png", 
		def = 60.0, 
		speed = 7.0,
		level = 100, 
		func = equip,
	},

	[248] = {
		name = "Wizard Armour |100|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2, 
		eimage = "gfx/weiwen1/wizard_armour.png", 
		fimage = "gfx/weiwen1/wizard_farmour.png",
		def = 100.0, 
		speed = 6.7,
		level = 100, 
		func = equip,
	},

	[249] = {
		name = "Wizard Legs |100|", 
		plural = "pairs of wizard legs", 
		article = "a pair of", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen1/wizard_flegs.png", 
		def = 60.0, 
		speed = 6.7,
		level = 100, 
		func = equip,
	},

	[250] = {
		name = "Wizard Boots |100|", 
		plural = "pairs of wizard boots", 
		article = "a pair of", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen1/wizard_boots.png",  
		speed = 12, 
		def = 5.0,
		level = 100, 
		func = equip,
	},

	[251] = {
		name = "Wizard Sword |100|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		eimage = "gfx/weiwen1/wizard_sword.png", 
		fimage = "gfx/weiwen1/wizard_sword.png", 
		offsetx = 6,
		offsety = 17,
		equip = 69,
		atk = 2100.0, 
		speed = 0, 
		level = 100, 
		func = equip,
	},

	[252] = {
		name = "Wizard Shield |100|", 
		desc = "It's procet from wizard.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen1/wizard_shield.png", 
		fimage = "gfx/weiwen1/wizard_fshield.png", 
		equip = 41,
		def = 110.0, 
		speed = 5.7, 
		level = 100, 
		func = equip,
	},
	
	[253] = {
		name = "Wizard Crossbow |100|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen1/wizard_bow.png", 
		fimage = "gfx/weiwen1/wizard_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 700.0, 
		speed = 0.3, 
		level = 100, 
		func = equip,
	},

	[254] = {
		name = "Wizard Book |100|", 
		r = 255, g = 255, b = 255, 
		action = "hold", 
		slot = 8, 
		fimage = "gfx/weiwen1/wizardbook.png", 
		def = 40.0,
		atk = 5.0, 
		speed = 7.5,
		atk = 50.0,
		level = 100, 
		func = equip,
	},
	
	[255] = {
		name = "Wizard Wings |100|", 
		r = 255, g = 255, b = 255, 
		action = "hold", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/wingsa.png", 
		eimage = "gfx/weiwen/wingsa.png", 
		def = 10.0,
		atk = 10.0, 
		speed = 30,
		level = 100, 
		func = equip,
	},
	
	[256] = {
		name = "Dark Helm |125|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1, 
		eimage = "gfx/weiwen/vip_helm.png", 
		fimage = "gfx/weiwen/vip_helm.png", 
		def = 120.0, 
		speed = 7.2,
		level = 125, 
		func = equip,
	},

	[257] = {
		name = "Dark Armour |125|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2, 
		eimage = "gfx/weiwen/vip_armor.png", 
		fimage = "gfx/weiwen/vip_farmor.png",
		def = 190.0, 
		speed = 7,
		level = 125, 
		func = equip,
	},

	[258] = {
		name = "Dark Legs |125|", 
		plural = "pairs of wizard legs", 
		article = "a pair of", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen/undeadlegs.png", 
		def = 120.0, 
		speed = 7,
		level = 125, 
		func = equip,
	},

	[259] = {
		name = "Dark Boots |125|", 
		plural = "pairs of wizard boots", 
		article = "a pair of", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/undeadboots.png",  
		speed = 12.2, 
		def = 10.0,
		level = 125, 
		func = equip,
	},

	[261] = {
		name = "Dark Shield |125|", 
		desc = "It's procet from wizard.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/dark_shield.png", 
		fimage = "gfx/weiwen/dark_fshield.png", 
		equip = 41,
		def = 220.0, 
		speed = 6, 
		level = 125, 
		func = equip,
	},
	
	[262] = {
		name = "Dark Crossbow |125|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/vip_bow.png", 
		fimage = "gfx/weiwen/vip_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 1350.0, 
		speed = 0.5, 
		level = 125, 
		func = equip,
	},
	
	[264] = {
		name = "Dark Wings |125|", 
		r = 255, g = 255, b = 255, 
		action = "hold", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/wings/bat.png", 
		eimage = "gfx/weiwen/wings/bat.png", 
		def = 20.0,
		atk = 20.0, 
		speed = 30.1,
		level = 125, 
		func = equip,
	},
	
	[265] = {
		name = "Hypnosis Armour |150|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2,
		fimage = "gfx/weiwen/hypnosis_farmour.png",  
		eimage = "gfx/weiwen/hypnosis_armour.png",  
		def = 380.0, 
		speed = 7.2,
		level = 150,
		func = equip,
	},

	[266] = {
		name = "Hypnosis Bow |150|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/hypnosis_bow.png", 
		fimage = "gfx/weiwen/hypnosis_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 2700.0, 
		speed = 0.5, 
		level = 150, 
		func = equip,
	},

	[267] = {
		name = "Hypnosis Helmet |150|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen/hypnosis_helmet.png",  
		eimage = "gfx/weiwen/hypnosis_helmet.png",  
		def = 240.0, 
		speed = 7.4,
		level = 150,
		func = equip,
	},
	
	[268] = {
		name = "Hypnosis Shield |150|", 
		desc = "It protects against god.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/hypnosis_shield.png", 
		fimage = "gfx/weiwen/hypnosis_fshield.png", 
		equip = 41,
		def = 400.0, 
		speed = 6.2, 
		level = 150, 
		func = equip,
	},
	
	[269] = {
		name = "Hypnosis Legs |150|", 
		plural = "pairs of wizard legs", 
		article = "a pair of", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen/hypnosis_legs.png", 
		def = 240.0, 
		speed = 7,
		level = 150, 
		func = equip,
	},

	[270] = {
		name = "Hypnosis Boots |150|", 
		plural = "pairs of wizard boots", 
		article = "a pair of", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/hypnosis_boots.png",  
		speed = 12.4, 
		def = 20.0,
		level = 150, 
		func = equip,
	},
	
	[284] = {
		name = "Hypnosis Wings |150|", 
		r = 255, g = 255, b = 255, 
		action = "hold", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/wings/fairy.png", 
		eimage = "gfx/weiwen/wings/fairy.png", 
		def = 40.0,
		atk = 40.0, 
		speed = 30.2,
		level = 150, 
		func = equip,
	},
	
	[271] = {
		name = "Holy Armour |175|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2,
		fimage = "gfx/weiwen/holy_armour.png",  
		eimage = "gfx/weiwen/holy_armour.png",  
		def = 760.0, 
		speed = 7.4,
		level = 175,
		func = equip,
	},

	[272] = {
		name = "Holy Bow |175|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/holy_bow.png", 
		fimage = "gfx/weiwen/holy_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 5000.0, 
		speed = 0.7, 
		level = 175, 
		func = equip,
	},

	[273] = {
		name = "Holy Helmet |175|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen/holy_helmet.png",  
		eimage = "gfx/weiwen/holy_helmet.png",  
		def = 450.0, 
		speed = 7.6,
		level = 175,
		func = equip,
	},
	
	[274] = {
		name = "Holy Shield |175|", 
		desc = "It protects against god.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/holy_shield.png", 
		fimage = "gfx/weiwen/holy_fshield.png", 
		equip = 41,
		def = 800.0, 
		speed = 6.4, 
		level = 175, 
		func = equip,
	},
	
	[275] = {
		name = "Holy Legs |175|", 
		plural = "pairs of wizard legs", 
		article = "a pair of", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen/holy_legs.png", 
		def = 450.0, 
		speed = 7.2,
		level = 175, 
		func = equip,
	},

	[276] = {
		name = "Holy Boots |175|", 
		plural = "pairs of wizard boots", 
		article = "a pair of", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/holy_boots.png",  
		speed = 12.6, 
		def = 40.0,
		level = 175, 
		func = equip,
	},
	
	[285] = {
		name = "Holy Wings |175|", 
		r = 255, g = 255, b = 255, 
		action = "hold", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/solar_aura.png", 
		eimage = "gfx/weiwen/solar_aura.png", 
		def = 80.0,
		atk = 80.0, 
		speed = 30.3,
		level = 175, 
		func = equip,
	},
	
	[277] = {
		name = "Fallen Angel Armour |200|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2,
		fimage = "gfx/weiwen/night_farmor.png",  
		eimage = "gfx/weiwen/night_armor.png",  
		def = 1400.0, 
		speed = 7.6,
		level = 200,
		func = equip,
	},

	[278] = {
		name = "Fallen Angel Bow |200|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/night_bow.png", 
		fimage = "gfx/weiwen/night_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 9000.0, 
		speed = 0.8, 
		level = 200, 
		func = equip,
	},

	[279] = {
		name = "Fallen Angel Helm |200|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen/night_helm.png",  
		eimage = "gfx/weiwen/night_helm.png",  
		def = 700.0, 
		speed = 7.6,
		level = 200,
		func = equip,
	},
	
	[280] = {
		name = "Fallen Angel Shield |200|", 
		desc = "It protects against fallen angels.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/fallenangel_shield.png", 
		fimage = "gfx/weiwen/fallenangel_fshield.png", 
		equip = 41,
		def = 1500.0, 
		speed = 6.5, 
		level = 200, 
		func = equip,
	},
	
	[281] = {
		name = "Fallen Angel Legs |200|", 
		plural = "pairs of fallen angel legs", 
		article = "a pair of", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen/night_legs.png", 
		def = 800.0, 
		speed = 7.4,
		level = 200, 
		func = equip,
	},

	[282] = {
		name = "Fallen Angel Boots |200|", 
		plural = "fallen angel boots", 
		article = "a pair of", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/night_boots.png",  
		speed = 12.8, 
		def = 80.0,
		level = 200, 
		func = equip,
	},
	
	[283] = {
		name = "Fallen Angel Wings |200|", 
		r = 255, g = 255, b = 255, 
		action = "hold", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/wings/dark_angel.png", 
		eimage = "gfx/weiwen/wings/dark_angel.png", 
		def = 160.0,
		atk = 160.0, 
		speed = 30.4,
		level = 200, 
		func = equip,
	},
	
	[284] = {
		name = "Underground City scroll", 
		desc = "Teleports you back to the underground city.", 
		r = 255, g = 255, b = 255, 
		action = "Use", 
		fimage = "gfx/weiwen/scroll.png", 
		func = { function(id, itemslot, itemid, equip)
				radiusmsg(player(id,"name") .. " used an underground city scroll.", player(id,"x"), player(id,"y"))
				parse("effect \"colorsmoke\" " .. player(id,"x") .. " " .. player(id,"y") .. " 5 5 255 255 255")
				local pos = 8560 .. " " .. 2576
				parse("effect \"colorsmoke\" " .. pos .. " 5 5 255 255 255")
				parse("setpos " .. id .. " " .. pos)
				radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
				destroyitem(id, itemslot, equip)
		
		end },
	},
	
	[300] = {
		name = "Island City scroll", 
		desc = "Teleports you back to the island city.", 
		r = 255, g = 255, b = 255, 
		action = "Use", 
		fimage = "gfx/weiwen/scroll.png", 
		func = { function(id, itemslot, itemid, equip)
				radiusmsg(player(id,"name") .. " used an island city scroll.", player(id,"x"), player(id,"y"))
				parse("effect \"colorsmoke\" " .. player(id,"x") .. " " .. player(id,"y") .. " 5 5 255 255 255")
				local pos = 10128 .. " " .. 5520
				parse("effect \"colorsmoke\" " .. pos .. " 5 5 255 255 255")
				parse("setpos " .. id .. " " .. pos)
				radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
				destroyitem(id, itemslot, equip)
		
		end },
	},
	
	[286] = {
		name = "Poison Armour |230|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2,
		fimage = "gfx/weiwen/poison_armour.png",  
		eimage = "gfx/weiwen/poison_armour.png",  
		def = 2500.0, 
		speed = 7.,
		level = 230,
		func = equip,
	},

	[287] = {
		name = "Poison Bow |230|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/poison_bow.png", 
		fimage = "gfx/weiwen/poison_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 15000.0, 
		speed = 0.8, 
		level = 230, 
		func = equip,
	},

	[288] = {
		name = "Poison Helm |230|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen/poison_helmet.png",  
		eimage = "gfx/weiwen/poison_helmet.png",  
		def = 1250.0, 
		speed = 7.6,
		level = 230,
		func = equip,
	},
	
	[289] = {
		name = "Poison Shield |230|", 
		desc = "It protects against fallen angels.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/poison_shield.png", 
		fimage = "gfx/weiwen/poison_fshield.png", 
		equip = 41,
		def = 3000.0, 
		speed = 6.5, 
		level = 230, 
		func = equip,
	},
	
	[290] = {
		name = "Poison Legs |230|", 
		plural = "pairs of fallen angel legs", 
		article = "a pair of", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen/poison_legs.png", 
		def = 1500.0, 
		speed = 7.4,
		level = 230, 
		func = equip,
	},

	[291] = {
		name = "Poison Boots |230|", 
		plural = "fallen angel boots", 
		article = "a pair of", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/poison_boots.png",  
		speed = 12.81, 
		def = 150.0,
		level = 230, 
		func = equip,
	},
	
	[292] = {
		name = "Poison Wings |230|", 
		r = 255, g = 255, b = 255, 
		action = "hold", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/poison_wings.png", 
		eimage = "gfx/weiwen/poison_wings.png", 
		def = 400.0,
		atk = 400.0, 
		speed = 30.41,
		level = 230, 
		func = equip,
	},
	
	
	[293] = {
		name = "BlackDragon Armour |260|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2,
		fimage = "gfx/weiwen1/blackdragon_farmour.png",  
		eimage = "gfx/weiwen1/blackdragon_armour.png",  
		def = 4000.0, 
		speed = 7.,
		level = 260,
		func = equip,
	},

	[294] = {
		name = "BlackDragon Bow |260|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen1/blackdragon_bow.png", 
		fimage = "gfx/weiwen1/blackdragon_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 25000.0, 
		speed = 0.8, 
		level = 260, 
		func = equip,
	},

	[295] = {
		name = "BlackDragon Helm |260|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen1/blackdragon_helmet.png",  
		eimage = "gfx/weiwen1/blackdragon_helmet.png",  
		def = 2000.0, 
		speed = 7.6,
		level = 260,
		func = equip,
	},
	
	[296] = {
		name = "BlackDragon Shield |260|", 
		desc = "It protects against blackdragon fire.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen1/blackdragon_shield.png", 
		fimage = "gfx/weiwen1/blackdragon_fshield.png", 
		equip = 41,
		def = 5000.0, 
		speed = 6.5, 
		level = 260, 
		func = equip,
	},
	
	[297] = {
		name = "BlackDragon Legs |260|", 
		plural = "pairs of BlackDragon legs", 
		article = "a pair of", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen1/blackdragon_legs.png", 
		def = 2500.0, 
		speed = 7.4,
		level = 260, 
		func = equip,
	},

	[298] = {
		name = "BlackDragon Boots |260|", 
		plural = "BlackDragon boots", 
		article = "a pair of", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen1/blackdragon_boots.png",  
		speed = 12.82, 
		def = 400.0,
		level = 260, 
		func = equip,
	},
	
	[299] = {
		name = "BlackDragon Wings |260|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/wings/evil.png", 
		eimage = "gfx/weiwen/wings/evil.png", 
		def = 1000.0,
		atk = 1000.0, 
		speed = 30.42,
		level = 260, 
		func = equip,
	},
	
		[300] = {
		name = "Golden City scroll", 
		desc = "Teleports you back to the golden city.", 
		r = 255, g = 255, b = 255, 
		action = "Use", 
		fimage = "gfx/weiwen/scroll.png", 
		func = { function(id, itemslot, itemid, equip)
				radiusmsg(player(id,"name") .. " used a golden city scroll.", player(id,"x"), player(id,"y"))
				parse("effect \"colorsmoke\" " .. player(id,"x") .. " " .. player(id,"y") .. " 5 5 255 255 255")
				local pos = 7888 .. " " .. 6640
				parse("effect \"colorsmoke\" " .. pos .. " 5 5 255 255 255")
				parse("setpos " .. id .. " " .. pos)
				radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
				destroyitem(id, itemslot, equip)
		
		end },
	}, 
	
	[301] = {
		name = "Legendary Armour |300|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 2,
		equip = 82, 
		fimage = "gfx/weiwen/tron_farmour.png",  
		eimage = "gfx/weiwen/tron_armour.png",  
		def = 7500.0, 
		speed = 7.5,
		level = 300,
		func = equip,
	},

	[302] = {
		name = "Legendary Bow |300|", 
		desc = "It requires you to hold it with two hands.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 3, 
		twohand = false, 
		eimage = "gfx/weiwen/tron_bow.png", 
		fimage = "gfx/weiwen/tron_bow.png", 
		offsety = 9,
		equip = 6,
		atk = 50000.0, 
		speed = 0.9, 
		level = 300, 
		func = equip,
	},

	[303] = {
		name = "Legendary Helm |300|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 1,
		fimage = "gfx/weiwen/tron_helm.png",  
		eimage = "gfx/weiwen/tron_helm.png",  
		def = 4000.0, 
		speed = 7.7,
		level = 300,
		func = equip,
	},
	
	[304] = {
		name = "Legendary Shield |300|", 
		desc = "It protects against anything. Made from adamantium.", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 4, 
		eimage = "gfx/weiwen/tron_shield.png", 
		fimage = "gfx/weiwen/tron_fshield.png", 
		equip = 41,
		def = 10000.0, 
		speed = 6.6, 
		level = 300, 
		func = equip,
	},
	
	[305] = {
		name = "Legendary Legs |300|", 
		plural = "pairs of Legendary  legs", 
		article = "a pair of", 
		r = 255, g = 255, b = 255,
		action = "equip", 
		slot = 5, 
		fimage = "gfx/weiwen/tron_legs.png", 
		def = 5000.0, 
		speed = 7.6,
		level = 300, 
		func = equip,
	},

	[306] = {
		name = "Legendary Boots |300|", 
		plural = "Legendary  boots", 
		article = "a pair of", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 6, 
		fimage = "gfx/weiwen/tron_boots.png",  
		speed = 13.0, 
		def = 1000.0,
		level = 300, 
		func = equip,
	},
	
	[307] = {
		name = "Legendary Wings |300|", 
		r = 255, g = 255, b = 255, 
		action = "equip", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/water_wings.png", 
		eimage = "gfx/weiwen/water_wings.png", 
		def = 2500.0,
		atk = 2500.0, 
		speed = 31.0,
		level = 300, 
		func = equip,
	},
		
	[200] = {
		name = "white bed",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 255, g = 255, b = 255,
	},

	[201] = {
		name = "pink bed",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 255, g = 128, b = 255,
	},

	[202] = {
		name = "green bed",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 128, g = 192, b = 0,
	},

	[203] = {
		name = "blue bed",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 0, g = 128, b = 192,
	},

	[204] = {
		name = "dark red bed",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 128, g = 0, b = 0,
	},

	[205] = {
		name = "light green bed",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 128, g = 255, b = 128,
	},

	[206] = {
		name = "light blue bed",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 128, g = 128, b = 255,
	},

	[207] = {
		name = "yellow bed",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 255, g = 255, b = 0,
	},

	[208] = {
		name = "orange bed",
		article = "an",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 255, g = 128, b = 0,
	},

	[209] = {
		name = "brown bed",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/bed.png", 
		offsety = 16,
		heal = 5, 
		r = 128, g = 64, b = 0,
	},

	[210] = {
		name = "white chair",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/chair.png", 
		r = 255, g = 255, b = 255,
		rot = 0,
		heal = 3, 
		action = "rotate|South", 
		func = function(id,itemslot,itemid) PLAYERS[id].Inventory[itemslot] = ((itemid-209)%4)+210; itemactions(id,itemslot) end,
	},

	[211] = {
		name = "white chair",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/chair.png", 
		r = 255, g = 255, b = 255,
		rot = 90,
		heal = 3, 
		action = "rotate|West", 
		func = function(id,itemslot,itemid) PLAYERS[id].Inventory[itemslot] = ((itemid-209)%4)+210; itemactions(id,itemslot) end,
	},

	[212] = {
		name = "white chair",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/chair.png", 
		rot = 180,
		heal = 3, 
		r = 255, g = 255, b = 255,
		action = "rotate|North", 
		func = function(id,itemslot,itemid) PLAYERS[id].Inventory[itemslot] = ((itemid-209)%4)+210; itemactions(id,itemslot) end,
	},

	[213] = {
		name = "white chair",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/chair.png", 
		rot = 270,
		heal = 3, 
		r = 255, g = 255, b = 255,
		action = "rotate|East", 
		func = function(id,itemslot,itemid) PLAYERS[id].Inventory[itemslot] = ((itemid-209)%4)+210; itemactions(id,itemslot) end,
	},

	[214] = {
		name = "brown chair",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/chair.png", 
		r = 169, g = 106, b = 44,
		rot = 0,
		heal = 3, 
		action = "rotate|South", 
		func = function(id,itemslot,itemid) PLAYERS[id].Inventory[itemslot] = ((itemid-213)%4)+214; itemactions(id,itemslot) end,
	},

	[215] = {
		name = "brown chair",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/chair.png", 
		r = 169, g = 106, b = 44,
		rot = 90,
		heal = 3, 
		action = "rotate|West", 
		func = function(id,itemslot,itemid) PLAYERS[id].Inventory[itemslot] = ((itemid-213)%4)+214; itemactions(id,itemslot) end,
	},

	[216] = {
		name = "brown chair",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/chair.png", 
		rot = 180,
		heal = 3, 
		r = 169, g = 106, b = 44,
		action = "rotate|North", 
		func = function(id,itemslot,itemid) PLAYERS[id].Inventory[itemslot] = ((itemid-213)%4)+214; itemactions(id,itemslot) end,
	},

	[217] = {
		name = "brown chair",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/chair.png", 
		rot = 270,
		heal = 3, 
		r = 169, g = 106, b = 44,
		action = "rotate|East", 
		func = function(id,itemslot,itemid) PLAYERS[id].Inventory[itemslot] = ((itemid-213)%4)+214; itemactions(id,itemslot) end,
	},

	[218] = {
		name = "white table",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/table.png", 
		r = 255, g = 255, b = 255,
	},

	[219] = {
		name = "brown table",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/table.png", 
		r = 169, g = 106, b = 44,
	},

	[220] = {
		name = "pikachu doll",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/pokemon/25.png", 
	},

	[221] = {
		name = "bulbasaur doll",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/pokemon/1.png", 
	},

	[222] = {
		name = "charmander doll",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/pokemon/4.png", 
	},

	[223] = {
		name = "squirtle doll",
		desc = "Used to furnish your house.",
		fimage = "gfx/weiwen/pokemon/7.png", 
	},
	
	[230] = {
		name = "coin", 
		desc = "Heads or tails?", 
		r = 255, g = 200, b = 0, 
		action = "flip", 
		fimage = "gfx/weiwen/circle.png", 
		func = function(id,itemslot,itemid)
			if PLAYERS[id].tmp.exhaust.use then
				return
			end
			PLAYERS[id].tmp.exhaust.use = true
			addtimer(CONFIG.EXHAUST.USE, rawset, PLAYERS[id].tmp.exhaust, "use", false)
			radiusmsg(player(id,"name") .. " flips a coin. " .. ((math.random(2) == 1) and "Heads!" or "Tails!"), player(id,"x"), player(id,"y"))
		end,
	}, 
	
	[231] = {
		name = "dice", 
		desc = "1d6.",
		r = 255, g = 192, b = 128, 
		action = "roll", 
		fimage = "gfx/weiwen/table.png", 
		fscalex = 0.5, 
		fscaley = 0.5, 
		func = function(id,itemslot,itemid)
			if PLAYERS[id].tmp.exhaust.use then
				return
			end
			PLAYERS[id].tmp.exhaust.use = true
			addtimer(CONFIG.EXHAUST.USE, rawset, PLAYERS[id].tmp.exhaust, "use", false)
			radiusmsg(player(id,"name") .. " rolls a " .. math.random(1, 6) .. ".", player(id,"x"), playerw(id,"y"))
		end,
	}, 


	[400] = {
		name = "Brown Horse |10|", 
		desc = "You move faster with it, but are unable to attack with it. Your defence is also reduced significantly.", 
		r = 162, g = 107, b = 0, 
		action = "ride", 
		slot = 7, 
		ground = true, 
		fimage = "gfx/weiwen/horse.png",  
		eimage = "gfx/weiwen/horse.png", 
		speed = 10, 
		def = -0.5, 
		level = 10, 
		func = equip,
	},

	[401] = {
		name = "White Horse |10|", 
		desc = "You move faster with it, but are unable to attack with it. Your defence is also reduced significantly.", 
		r = 255, g = 255, b = 255, 
		action = "ride", 
		slot = 7, 
		ground = true, 
		fimage = "gfx/weiwen/horse.png",  
		eimage = "gfx/weiwen/horse.png", 
		speed = 10, 
		def = -0.5, 
		level = 10, 
		func = equip,
	},

	[402] = {
		name = "Grey Horse |10|", 
		desc = "You move faster with it, but are unable to attack with it. Your defence is also reduced significantly.", 
		r = 175, g = 177, b = 186, 
		action = "ride", 
		slot = 7, 
		ground = true, 
		fimage = "gfx/weiwen/horse.png",  
		eimage = "gfx/weiwen/horse.png", 
		speed = 10, 
		def = -0.5, 
		level = 10, 
		func = equip,
	},

	[403] = {
		name = "Black Horse |10|", 
		desc = "You move faster with it, but are unable to attack with it. Your defence is also reduced significantly.", 
		r = 50, g = 50, b = 50, 
		action = "ride", 
		slot = 7, 
		ground = true, 
		fimage = "gfx/weiwen/horse.png",  
		eimage = "gfx/weiwen/horse.png", 
		speed = 10, 
		def = -0.5, 
		level = 10, 
		func = equip,
	},

	[404] = {
		name = "SeaHorse |10|", 
		desc = "You move faster with it, but are unable to attack with it. Your defence is also reduced significantly.", 
		r = 32, g = 121, b = 155, 
		action = "ride", 
		slot = 7, 
		ground = true, 
		water = true, 
		fimage = "gfx/weiwen/horse.png",  
		eimage = "gfx/weiwen/horse.png",  
		fscalex = 1.2, 
		fscaley = 0.8, 
		escalex = 1.2, 
		escaley = 0.8, 
		offsety = 20, 
		speed = 10, 
		def = -0.5, 
		level = 10, 
		func = equip,
	},
	
		[458] = {
		name = "Earth Armour lvl 1", 
		desc = "A not so powerfull armor adding spell which creates an earth armour.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		fimage = "gfx/weiwen/nick/earth_armor.png",  
		himage = "gfx/weiwen/nick/earth_armor.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 15 then
			radiusmsg(player(id,"name") .. " casts Earth Armor lvl 1", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 120")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-15			
			PLAYERS[id].tmp.def = PLAYERS[id].tmp.def + 5
							addtimer(15000, function(id)
					PLAYERS[id].tmp.def = PLAYERS[id].tmp.def - 5
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Earth Armor lvl 1 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
			[459] = {
		name = "Water Heal lvl 1", 
		desc = "A not so powerfull spell used to heal your wounds with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		fimage = "gfx/weiwen/nick/heal.png",  
		himage = "gfx/weiwen/nick/heal.png", 
		func = {equip, function(id,itemslot,itemid,equip)
		if PLAYERS[id]['Mana'] > 40 then
			radiusmsg(player(id,"name") .. " casts Water Heal lvl 1", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 32, -50, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 255")
			radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-40
		else
			radiusmsg(player(id,"name") .. " attempts to cast Water Heal lvl 1 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end},
	},

		[460] = {
		name = "Earth Armour lvl 5", 
		desc = "A legendary armor adding spell which creates an earth armour.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		level = 200,
		fimage = "gfx/weiwen/nick/earth_armor.png",  
		himage = "gfx/weiwen/nick/earth_armor.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 35 then
			radiusmsg(player(id,"name") .. " casts Earth Armor lvl 5", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 120")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-35			
			PLAYERS[id].tmp.def = PLAYERS[id].tmp.def + 10000
							addtimer(35000, function(id)
					PLAYERS[id].tmp.def = PLAYERS[id].tmp.def - 10000
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Earth Armor lvl 5 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[461] = {
		name = "Earth Armour lvl 2", 
		desc = "A quite powerfull armor adding spell which creates an earth armour.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		level = 20,
		fimage = "gfx/weiwen/nick/earth_armor.png",  
		himage = "gfx/weiwen/nick/earth_armor.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 20 then
			radiusmsg(player(id,"name") .. " casts Earth Armor lvl 3", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 120")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-20			
			PLAYERS[id].tmp.def = PLAYERS[id].tmp.def + 50
							addtimer(20000, function(id)
					PLAYERS[id].tmp.def = PLAYERS[id].tmp.def - 50
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Earth Armor lvl 3 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[462] = {
		name = "Earth Armour lvl 3", 
		desc = "A powerfull armor adding spell which creates an earth armour.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		level = 50,
		fimage = "gfx/weiwen/nick/earth_armor.png",  
		himage = "gfx/weiwen/nick/earth_armor.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 25 then
			radiusmsg(player(id,"name") .. " casts Earth Armor lvl 4", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 120")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-25			
			PLAYERS[id].tmp.def = PLAYERS[id].tmp.def + 400
							addtimer(25000, function(id)
					PLAYERS[id].tmp.def = PLAYERS[id].tmp.def - 400
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Earth Armor lvl 4 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[463] = {
		name = "Earth Armour lvl 4", 
		desc = "A very powerfull armor adding spell which creates an earth armour.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		level = 100,
		fimage = "gfx/weiwen/nick/earth_armor.png",  
		himage = "gfx/weiwen/nick/earth_armor.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 30 then
			radiusmsg(player(id,"name") .. " casts Earth Armor lvl 4", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 120")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-30			
			PLAYERS[id].tmp.def = PLAYERS[id].tmp.def + 1000
							addtimer(30000, function(id)
					PLAYERS[id].tmp.def = PLAYERS[id].tmp.def - 1000
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Earth Armor lvl 4 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
			[464] = {
		name = "Water Heal lvl 2", 
		desc = "A quite powerfull spell used to heal your wounds with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		fimage = "gfx/weiwen/nick/heal.png",  
		himage = "gfx/weiwen/nick/heal.png", 
		func = {equip, function(id,itemslot,itemid,equip)
		if PLAYERS[id]['Mana'] > 35 then
			radiusmsg(player(id,"name") .. " casts Water Heal lvl 2", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 32, -75, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 255")
			radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-35
		else
			radiusmsg(player(id,"name") .. " attempts to cast Water Heal lvl 2 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end},
	},
	
			[465] = {
		name = "Water Heal lvl 3", 
		desc = "A  powerfull spell used to heal your wounds with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		fimage = "gfx/weiwen/nick/heal.png",  
		himage = "gfx/weiwen/nick/heal.png", 
		func = {equip, function(id,itemslot,itemid,equip)
		if PLAYERS[id]['Mana'] > 25 then
			radiusmsg(player(id,"name") .. " casts Water Heal lvl 3", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 32, -90, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 255")
			radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-25
		else
			radiusmsg(player(id,"name") .. " attempts to cast Water Heal lvl 3 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end},
	},
	
			[466] = {
		name = "Water Heal lvl 4", 
		desc = "A very powerfull spell used to heal your wounds with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		level = 100,
		fimage = "gfx/weiwen/nick/heal.png",  
		himage = "gfx/weiwen/nick/heal.png", 
		func = {equip, function(id,itemslot,itemid,equip)
		if PLAYERS[id]['Mana'] > 15 then
			radiusmsg(player(id,"name") .. " casts Water Heal lvl 4", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 32, -100, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 255")
			radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-15
		else
			radiusmsg(player(id,"name") .. " attempts to cast Water Heal lvl 4 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end},
	},
	
			[467] = {
		name = "Water Heal lvl 5", 
		desc = "A legendary spell used to heal your wounds with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		level = 200,
		fimage = "gfx/weiwen/nick/heal.png",  
		himage = "gfx/weiwen/nick/heal.png", 
		func = {equip, function(id,itemslot,itemid,equip)
		if PLAYERS[id]['Mana'] > 5 then
			radiusmsg(player(id,"name") .. " casts Water Heal lvl 5", player(id,"x"), player(id,"y"))
			explosion(player(id, "x"), player(id,"y"), 32, -125, id)
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 120 120 255")
			radiussound("materials/glass2.wav", player(id,"x"), player(id,"y"))
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-5
		else
			radiusmsg(player(id,"name") .. " attempts to cast Water Heal lvl 5 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end},
	},
	
			[468] = {
		name = "Small mana potion", 
		desc = "A small mana potion that heals 25 mana.", 
		r = 255, g = 255, b = 255, 
		action = {"hold", "drink"}, 
		slot = 9, 
		fimage = "gfx/weiwen/minipot.png",
		func = {equip, function(id,itemslot,itemid,equip)
		if PLAYERS[id]['Mana'] < 100+round(PLAYERS[id].Level / 5) then
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']+25
			destroyitem(id, itemslot, equip)
			updateHUD(id)
		message(id, "You have used a Small mana potion.", "255255255")
		else
		message(id, "You are alredy at full mana!", "255128000")
		end
		if PLAYERS[id]['Mana'] > 100+round(PLAYERS[id].Level / 5) then
			PLAYERS[id]['Mana'] = 100+round(PLAYERS[id].Level / 5)
		end
		updateHUD(id)
		end},
	},
	
			[469] = {
		name = "Medium mana potion", 
		desc = "A medium mana potion that heals 50 mana. Bought from the magic shop.", 
		r = 255, g = 255, b = 255, 
		action = {"hold", "drink"}, 
		slot = 9, 
		fimage = "gfx/weiwen/medpot.png",
		func = {equip, function(id,itemslot,itemid,equip)
		if PLAYERS[id]['Mana'] < 100+round(PLAYERS[id].Level / 5) then
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']+50
			destroyitem(id, itemslot, equip)
			updateHUD(id)
		message(id, "You have used a Medium Mana Potion.", "255255255")
		else
		message(id, "You are alredy at full mana!", "255128000")
		end
		if PLAYERS[id]['Mana'] > 100+round(PLAYERS[id].Level / 5) then
			PLAYERS[id]['Mana'] = 100+round(PLAYERS[id].Level / 5)
		end
		updateHUD(id)
		end},
	},
	
			[470] = {
		name = "Large mana potion", 
		desc = "A large mana potion that fully heals your mana. Made from dragon spit.", 
		r = 255, g = 255, b = 255, 
		action = {"hold", "drink"}, 
		slot = 9, 
		fimage = "gfx/weiwen/bigpot.png",
		func = {equip, function(id,itemslot,itemid,equip)
		if PLAYERS[id]['Mana'] < 100+round(PLAYERS[id].Level / 5) then
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']+100
			destroyitem(id, itemslot, equip)
			updateHUD(id)
		message(id, "You have used a Large Mana Potion.", "255255255")
		else
		message(id, "You are alredy at full mana!", "255128000")
		end
		if PLAYERS[id]['Mana'] > 100+round(PLAYERS[id].Level / 5) then
			PLAYERS[id]['Mana'] = 100+round(PLAYERS[id].Level / 5)
		end
		updateHUD(id)
		end},
	},
	
		[471] = {
		name = "Wind Rush lvl 1", 
		desc = "A not so powerfull speed adding spell which makes the winds go with you.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		fimage = "gfx/weiwen/windspell.png",  
		himage = "gfx/weiwen/windspell.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 35 then
			radiusmsg(player(id,"name") .. " casts Wind Rush lvl 1", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana'] - 35			
			PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd + 5
			parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
							addtimer(15000, function(id)
					PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd - 5
					parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Wind Rush lvl 1 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},

		[472] = {
		name = "Wind Rush lvl 5", 
		desc = "A legendary speed adding spell which makes the winds go with you.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		level = 200,
		fimage = "gfx/weiwen/windspell.png",  
		himage = "gfx/weiwen/windspell.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 15 then
			radiusmsg(player(id,"name") .. " casts Wind Rush lvl 5", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana']-15			
			PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd + 20
			parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
							addtimer(35000, function(id)
					PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd - 20
					parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Wind Rush lvl 5 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[473] = {
		name = "Wind Rush lvl 2", 
		desc = "A quite powerfull speed adding spell which makes the winds go with you.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		level = 20,
		fimage = "gfx/weiwen/windspell.png",  
		himage = "gfx/weiwen/windspell.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 20 then
			radiusmsg(player(id,"name") .. " casts Wind Rush lvl 2", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana'] - 10			
			PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd + 10
			parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
							addtimer(20000, function(id)
					PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd - 10
					parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Wind Rush lvl 2 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[474] = {
		name = "Wind Rush lvl 3", 
		desc = "A powerfull speed adding spell which makes the winds go with you.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		level = 50,
		fimage = "gfx/weiwen/windspell.png",  
		himage = "gfx/weiwen/windspell.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 25 then
			radiusmsg(player(id,"name") .. " casts Wind Rush lvl 3", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana'] - 25			
			PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd + 15
			parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
							addtimer(25000, function(id)
					PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd - 15
					parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Wind Rush lvl 3 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[475] = {
		name = "Wind Rush lvl 4", 
		desc = "A very powerfull speed adding spell which makes the winds go with you.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		level = 100,
		fimage = "gfx/weiwen/windspell.png",  
		himage = "gfx/weiwen/windspell.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 20 then
			radiusmsg(player(id,"name") .. " casts Wind Rush lvl 4", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana'] - 20			
			PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd + 18
			parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
							addtimer(30000, function(id)
					PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd - 18
					parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Wind Rush lvl 4 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[476] = {
		name = "Fire Atacks lvl 1", 
		desc = "A not so powerfull atack adding spell which makes your weapon throw fire.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		fimage = "gfx/weiwen/nick/fire_atacks.png",  
		himage = "gfx/weiwen/nick/fire_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 70 then
			radiusmsg(player(id,"name") .. " casts Fire Atacks lvl 1", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana'] - 70			
			PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk + 2.5
							addtimer(8000, function(id)
					PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk - 2.5
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Fire Atacks lvl 1 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},

		[477] = {
		name = "Fire Atacks lvl 5", 
		desc = "A legendary atack adding spell which makes yout weapon throw fire.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		level = 200,
		fimage = "gfx/weiwen/nick/fire_atacks.png",  
		himage = "gfx/weiwen/nick/fire_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 25 then
			radiusmsg(player(id,"name") .. " casts Fire Atacks lvl 5", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana'] - 25			
			PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk + 25000
							addtimer(20000, function(id)
					PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk - 25000
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Fire Atacks lvl 5 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[478] = {
		name = "Fire Atacks lvl 2", 
		desc = "A quite powerfull atack adding spell which makes the winds go with you.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		level = 20,
		fimage = "gfx/weiwen/nick/fire_atacks.png",  
		himage = "gfx/weiwen/nick/fire_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 60 then
			radiusmsg(player(id,"name") .. " casts Fire Atacks lvl 2", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana'] - 60			
			PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk + 20
							addtimer(10000, function(id)
					PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk - 20
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Fire Atacks lvl 2 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[479] = {
		name = "Fire Atacks lvl 3", 
		desc = "A powerfull atack adding spell which makes your atacks throw fire.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		level = 50,
		fimage = "gfx/weiwen/nick/fire_atacks.png",  
		himage = "gfx/weiwen/nick/fire_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 50 then
			radiusmsg(player(id,"name") .. " casts Fire Atacks lvl 3", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana'] - 50			
			PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk + 350
							addtimer(12500, function(id)
					PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk - 350
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Fire Atacks lvl 3 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[480] = {
		name = "Fire Atacks lvl 4", 
		desc = "A very powerfull atack adding spell which makes your weapon throw fire.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		level = 100,
		fimage = "gfx/weiwen/nick/fire_atacks.png",  
		himage = "gfx/weiwen/nick/fire_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			if PLAYERS[id]['Mana'] > 40 then
			radiusmsg(player(id,"name") .. " casts Fire Atacks lvl 4", player(id,"x"), player(id,"y"))
			local pos = player(id,"x") .. " " .. player(id,"y")
			parse("effect \"colorsmoke\" " .. pos .. " 5 5 0 0 0")
			PLAYERS[id]['Mana'] = PLAYERS[id]['Mana'] - 40			
			PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk + 7000
							addtimer(15000, function(id)
					PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk - 7000
					updateHUD(id)
				end, id)
			else
			radiusmsg(player(id,"name") .. " attempts to cast Fire Atacks lvl 4 but lacks mana", player(id,"x"), player(id,"y"))
		end
		updateHUD(id)
		end}, 
	},
	
		[481] = {
		name = "Icy Atacks lvl 1", 
 		desc = "A not so powerfull passive health adding spell which infues your armour with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		def = 0.5, 
		fimage = "gfx/weiwen/nick/icy_atacks.png",  
		himage = "gfx/weiwen/nick/icy_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Icy Atacks lvl 1 but it's a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},

		[482] = {
		name = "Icy Atacks lvl 5", 
 		desc = "A legendary passive health adding spell which infues your armour with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		level = 200,
		def = 1000.0, 
		fimage = "gfx/weiwen/nick/icy_atacks.png",  
		himage = "gfx/weiwen/nick/icy_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Icy Atacks lvl 5 but it's a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},
	
		[483] = {
		name = "Icy Atacks lvl 2", 
 		desc = "A quite powerfull passive health adding spell which infues your armour with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		level = 20,
		def = 3.0, 
		fimage = "gfx/weiwen/nick/icy_atacks.png",  
		himage = "gfx/weiwen/nick/icy_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Icy Atacks lvl 2 but it's a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},
	
		[484] = {
		name = "Icy Atacks lvl 3",
 		desc = "A powerfull passive health adding spell which infues your armour with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		level = 50,
		def = 6.0, 
		fimage = "gfx/weiwen/nick/icy_atacks.png",  
		himage = "gfx/weiwen/nick/icy_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Icy Atacks lvl 3 but it's a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},
	
		[485] = {
		name = "Icy Atacks lvl 4", 
		desc = "A very powerfull passive health adding spell which infues your armour with water.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 11, 
		level = 100,
		def = 90.0, 
		fimage = "gfx/weiwen/nick/icy_atacks.png",  
		himage = "gfx/weiwen/nick/icy_atacks.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Icy Atacks lvl 4 but it's a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},
	
		[486] = {
		name = "Earth Vitality lvl 1", 
		desc = "A not so powerfull passive health adding spell which makes you as strong as the earth.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		hp = 15, 
		fimage = "gfx/weiwen/nick/earth_vitality.png",  
		himage = "gfx/weiwen/nick/earth_vitality.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Earth Vitality lvl 1 but it is a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},

		[487] = {
		name = "Earth Vitality lvl 5", 
		desc = "A legendary passive health adding spell which makes you as strong as the earth.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		level = 200,
		hp = 100, 
		fimage = "gfx/weiwen/nick/earth_vitality.png",  
		himage = "gfx/weiwen/nick/earth_vitality.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Earth Vitality lvl 5 but it is a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},
	
		[488] = {
		name = "Earth Vitality lvl 2", 
		desc = "A quite powerfull passive health adding spell which makes you as strong as the earth.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		level = 20,
		hp = 30, 
		fimage = "gfx/weiwen/nick/earth_vitality.png",  
		himage = "gfx/weiwen/nick/earth_vitality.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Earth Vitality lvl 2 but it is a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},
	
		[489] = {
		name = "Earth Vitality lvl 3", 
		desc = "A powerfull passive health adding spell which makes you as strong as the earth.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		level = 50,
		hp = 50, 
		fimage = "gfx/weiwen/nick/earth_vitality.png",  
		himage = "gfx/weiwen/nick/earth_vitality.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Earth Vitality lvl 3 but it is a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},
	
		[490] = {
		name = "Earth Vitality lvl 4", 
		desc = "A very powerfull passive health adding spell which makes you as strong as the earth.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 10, 
		level = 100,
		hp = 75, 
		fimage = "gfx/weiwen/nick/earth_vitality.png",  
		himage = "gfx/weiwen/nick/earth_vitality.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			radiusmsg(player(id,"name") .. " attempts to cast Earth Vitality lvl 4 but it is a passive skill \lol/", player(id,"x"), player(id,"y"))
		end}, 
	},
	
		[491] = {
		name = "Fire Ball lvl 1", 
		desc = "A not so powerfull fire ball throwing spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		fimage = "gfx/weiwen/fireball.png",  
		himage = "gfx/weiwen/fireball.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 350, "gfx/weiwen/fireball.png", 5, 75, "FireBall lvl 1", 13, true)
		end}, 
	},
	
		[492] = {
		name = "Fire Ball lvl 2", 
		desc = "A quite powerfull fire ball throwing spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		fimage = "gfx/weiwen/fireball.png",  
		himage = "gfx/weiwen/fireball.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 400, "gfx/weiwen/fireball.png", 100, 65, "FireBall lvl 2", 13, true)
		end}, 
	},
	
		[493] = {
		name = "Fire Ball lvl 3", 
		desc = "A powerfull fire ball throwing spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		fimage = "gfx/weiwen/fireball.png",  
		himage = "gfx/weiwen/fireball.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 400, "gfx/weiwen/fireball.png", 500, 60, "FireBall lvl 3", 13, true)
		end}, 
	},
	
		[494] = {
		name = "Fire Ball lvl 4", 
		desc = "A very powerfull fire ball throwing spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		fimage = "gfx/weiwen/fireball.png",  
		himage = "gfx/weiwen/fireball.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 450, "gfx/weiwen/fireball.png", 15000, 50, "FireBall lvl 4", 13, true)
		end}, 
	},
	
		[495] = {
		name = "Fire Ball lvl 5", 
		desc = "A legendary fire ball throwing spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 13, 
		fimage = "gfx/weiwen/fireball.png",  
		himage = "gfx/weiwen/fireball.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 500, "gfx/weiwen/fireball.png", 200000, 45, "FireBall lvl 5", 13, true)
		end}, 
	},
	
		[496] = {
		name = "Tornado lvl 1", 
		desc = "A not so powerfull tornado spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		fimage = "gfx/weiwen/tornado.png",  
		himage = "gfx/weiwen/tornado.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 300, "gfx/weiwen/tornado.png", 4, 60, "Tornado lvl 1", 12, false)
		end}, 
	},
	
		[497] = {
		name = "Tornado lvl 2", 
		desc = "A quite powerfull tornado spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		fimage = "gfx/weiwen/tornado.png",  
		himage = "gfx/weiwen/tornado.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 300, "gfx/weiwen/tornado.png", 80, 55, "Tornado lvl 2", 12, false)
		end}, 
	},
	
		[498] = {
		name = "Tornado lvl 3", 
		desc = "A powerfull tornado spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		fimage = "gfx/weiwen/tornado.png",  
		himage = "gfx/weiwen/tornado.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 350, "gfx/weiwen/tornado.png", 400, 45, "Tornado lvl 3", 12, false)
		end}, 
	},
	
		[499] = {
		name = "Tornado lvl 4", 
		desc = "A very powerfull tornado spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		fimage = "gfx/weiwen/tornado.png",  
		himage = "gfx/weiwen/tornado.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 400, "gfx/weiwen/tornado.png", 12000, 40, "Tornado lvl 4", 12, false)
		end}, 
	},
	
		[500] = {
		name = "Tornado lvl 5", 
		desc = "A legendary tornado spell.", 
		r = 255, g = 255, b = 255, 
		action = {"equip", "cast"}, 
		slot = 12, 
		fimage = "gfx/weiwen/tornado.png",  
		himage = "gfx/weiwen/tornado.png", 
		func = {equip, function(id,itemslot,itemid,equip)
			DamageSpell(id, 450, "gfx/weiwen/tornado.png", 175000, 35, "Tornado lvl 5", 12, false)
		end}, 
	},
	
	
	
	
	[1337] = {
		name = 'money', 
		article = 'some', 
		r = 0, g = 150, b = 0, 
		fimage = 'gfx/weiwen/money.png', 
	}
}

for k, v in pairs(ITEMS) do
	v.article = v.article or "a"
	v.plural = v.plural or v.name .. "s"
	v.action = type(v.action) == "table" and v.action or {v.action}
	v.func = type(v.func) == "table" and v.func or {v.func}
end