Monster = {name = 'Monster', health = 100, image = 'gfx/weiwen/circle.png', scalex = 1, scaley = 1, atk = 1, def = 1, spd = 5, x = 0, y = 0, ang = 0, imgang = 0, exp = 5, money = 50, type = 'monster', loot = {}}
MONSTERS = {}
local t = 0

CONFIG.MONSTERS = {
	{
		name = 'Zombie', health = 200, image = 'gfx/weiwen/pokemon/suicide_zombie.png', scalex = 1.5, scaley = 1.5, 
		atk = 1.2, def = 1.0, spd = 9, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 30, runat = 20, spawn1 = {0, 0}, spawn2 = {110, 125}, 
		exp = 30, money = 150, loot = {{ chance = 50 , id = 17},{ chance = 25 , id = 18},{ chance = 20, id = 8}}, 
	}, 
	{
		name = 'MiniRock', health = 100, image = 'gfx/weiwen/pokemon/216.png', scalex = 0.9, scaley = 0.9, 
		atk = 1.4, def = 1.5, spd = 6, atkspd = 10, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 100, runat = 20, spawn1 = {6, 5}, spawn2 = {58, 18}, 
		exp = 13, money = 100, loot = {{chance = 30, id = 4},{ chance = 10 , id = 17},{ chance = 50 , id = 18},{ chance = 50 , id = 1}}, 
	}, 
	{
		name = 'Dongo', health = 200, image = 'gfx/weiwen/pokemon/500.png', scalex = 1.2, scaley = 1.2, 
		atk = 1.4, def = 1.0, spd = 9, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 30, runat = 20, spawn1 = {34, 30}, spawn2 = {67, 102}, 
		exp = 24, money =130, loot = {{ chance = 50 , id = 17},{ chance = 25 , id = 18}}, 
		spc = {2500, function(self, id, dist) 
			if not self.agility then
				radiusmsg("Dongo rushes towards you!", self.x, self.y)
				parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 000 000 000")
				radiussound("weapons/g_flash.wav", self.x, self.y)
				self.spd = 10
				self.agility = true
				imagecolor(self.image, 155, 255, 155)
				addtimer(5000, function(self)
					self.spd = 13
					imagecolor(self.image, 255, 255, 255)
					self.agility = nil
				end, self)
			elseif dist <= 32 then
				self:hit(id, 10)
			end
		end},
	}, 
	{
		name = 'Djin', health = 180, image = 'gfx/weiwen/pokemon/e3.png', scalex = 1.0, scaley = 1.0, 
		atk = 2.2, def = 1.0, spd = 9, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 30, runat = 0, spawn1 = {2, 85}, spawn2 = {25, 105}, 
		exp = 19, money = 110, loot = {{chance = 50, id = 104}}, 
	}, 
	{
		name = 'Drakon', health = 350, image = 'gfx/weiwen/pokemon/e2.png', scalex = 1.8, scaley = 1.8, 
		atk = 3, def = 1.1, spd = 10, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 30, runat = 0, range = 48, spawn1 = {132, 2}, spawn2 = {197, 78}, 
		exp = 180, money = 250, loot = {{chance = 50, id = 104}},
		spc = {40, function(self, id, dist) 
			radiusmsg("Drakon throws fire from it's mouth!", self.x, self.y)
			local x1, y1 = self.x, self.y
			local rot = math.atan2(player(id, 'y')-y1, player(id, 'x')-x1) + math.pi/2
			local x2, y2 = math.sin(rot), -math.cos(rot)
			local fire = image("gfx/sprites/spot.bmp", 0, 0, 1)
			imagepos(fire, x1+x2*64, y1+y2*64, math.deg(rot)+180)
			imagescale(fire, 1.5, 2)
			imagecolor(fire, 255, 64, 0)
			imageblend(fire, 1)
			addtimer(500, freeimage, fire)
			parse('explosion ' .. x1+x2*100 .. ' ' .. y1+y2*100 .. ' 120 18')
			parse('explosion ' .. x1+x2*50 .. ' ' .. y1+y2*50 .. ' 100 20')
		end},
	}, 
	{
		name = 'Rock', health = 150, image = 'gfx/weiwen/pokemon/e20.png', scalex = 1, scaley = 1, r = 64, g = 64, b = 64, 
		atk = 1.8, def = 4.0, spd = 4, atkspd = 10, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 15, runat = 0, range = 64, spawn1 = {36, 5}, spawn2 = {58, 18}, 
		exp = 400, money = 500, loot = {{chance = 1500, id = 116},{chance = 1500, id = 117},{chance = 1500, id = 118},{chance = 1500, id = 119},{chance = 1500, id = 120},{chance = 1500, id = 121},{chance = 1500, id = 122},{chance = 1500, id = 123}}, 
		spc = {1000, function(self) 
			if not self.harden then
				radiusmsg("The Rock hardens itself, making it more resistant!", self.x, self.y)
				parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 192 192 192")
				radiussound("weapons/g_flash.wav", self.x, self.y)
				self.def = 8.0
				self.harden = true
				imagecolor(self.image, 155, 155, 255)
				addtimer(5000, function(self)
					self.def = 5
					imagecolor(self.image, 255, 255, 255)
					self.harden = nil
				end, self)
			end
		end},
	},
	{
		name = 'Dragon', health = 700, image = 'gfx/weiwen/pokemon/firedragon.png', scalex = 2, scaley = 2, r = 128, g = 0, b = 0, 
		atk = 8, def = 1.15, spd = 12, atkspd = 15, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 15, runat = 0, range = 80, spawn1 = {163, 3}, spawn2 = {187, 21}, 
		exp = 900, money = 900, loot = {{chance = 1000, id = 137},{chance = 1000, id = 138},{chance = 1000, id = 139},{chance = 1000, id = 140},{chance = 250, id = 141},{chance = 250, id = 142},{chance = 250, id = 143},{chance = 250, id = 144},{chance = 250, id = 233}}, 
		spc = {200, function(self, id, dist) 
			radiusmsg("Dragon uses flamethrower!", self.x, self.y)
			local x1, y1 = self.x, self.y
			local rot = math.atan2(player(id, 'y')-y1, player(id, 'x')-x1) + math.pi/2
			local x2, y2 = math.sin(rot), -math.cos(rot)
			local fire = image("gfx/sprites/spot.bmp", 0, 0, 1)
			imagepos(fire, x1+x2*64, y1+y2*64, math.deg(rot)+180)
			imagescale(fire, 1.5, 2)
			imagecolor(fire, 255, 64, 0)
			imageblend(fire, 1)
			addtimer(500, freeimage, fire)
			parse('explosion ' .. x1+x2*100 .. ' ' .. y1+y2*100 .. ' 120 35')
			parse('explosion ' .. x1+x2*50 .. ' ' .. y1+y2*50 .. ' 100 35')
		end},
	}, 
	{
		name = 'Nature', health = 1300, image = 'gfx/weiwen/pokemon/e18.png', scalex = 1.2, scaley = 1.2, 
		atk = 9, def = 1.25, spd = 15, atkspd = 11, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 15, runat = 0, range = 48, spawn1 = {84, 6}, spawn2 = {89, 13}, 
		exp = 1500, money = 1750, loot = {{chance=1500,id=234},{chance=1500,id=150},{chance=1500,id=239},{chance=1500,id=149},{chance=1500,id=148},{chance=1500,id=147},{chance=1500,id=146},{chance=1500,id=145}}, 
		spc = {500, function(self, id, dist) 
			parse('explosion ' .. self.x .. ' ' .. self.y .. ' 10 -150')
			parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 0 255 255")
			radiusmsg("Nature heals itself!", self.x, self.y)
			radiussound("muhaha.wav", self.x, self.y)
		end},
	}, 
	
	{
	name = 'Mage', health = 2500, image = 'gfx/weiwen/pokemon/645.png', scalex = 2, scaley = 2, 
	atk = 20, def = 1.3, spd = 17, atkspd = 12, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 30, runat = 0, range = 48, spawn1 = {215, 34}, spawn2 = {236, 66}, 
	exp = 2000, money = 1500, loot = {{chance=1000,id=151},{chance=1000,id=236},{chance=1000,id=155},{chance=1500,id=156},{chance=1000,id=153},{chance=1000,id=152},{chance=1000,id=154},{chance=1500,id=235}}, 
	spc = {500, function(self, id, dist) 
			local range,dmg,erange,rept,gr,xx,yy = 300,6,128,math.random(15,30),0,self.x,self.y
			radiusmsg("Mage casts a meteor shower.", self.x, self.y)
			radiussound("materials/glass3.wav", self.x, self.y)
			repeat
				xx,yy=self.x,self.y
				xx=xx+math.random(1,range)-math.random(1,range)
				yy=yy+math.random(1,range)-math.random(1,range)
				parse('explosion ' .. xx .. ' ' .. yy .. ' ' .. erange .. ' ' .. dmg .. ' 0')
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 100 100 200")
				radiussound("cs2d_tibia/blizz.ogg", self.x, self.y)
				gr = gr + 1
			until gr >= rept
		end},
	}, 

	{
		name = 'Ice Giant', health = 4000, image = 'gfx/weiwen/pokemon/Ice.png', scalex = 2, scaley = 2, 
		atk = 30, def = 1.3, spd = 21, atkspd = 14, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 15, runat = 0, range = 48, spawn1 = {2, 172}, spawn2 = {69, 198}, 
		exp = 3000, money = 5000, loot = {{chance = 1000, id = 237},{chance = 1000, id = 166},{chance = 1000, id = 165},{chance = 1000, id = 164},{chance = 1000, id = 163},{chance = 1000, id = 162},{chance = 1000, id = 161},{chance = 2000, id = 160},{chance = 1000, id = 159},{chance = 1000, id = 158}},
		spc = {500, function(self, id, dist) 
			local range,dmg,erange,rept,gr,xx,yy = 300,40,128,math.random(10,20),0,self.x,self.y
			radiusmsg("Ice Giant casts a ice storm.", self.x, self.y)
			radiussound("materials/glass3.wav", self.x, self.y)
			repeat
				xx,yy=self.x,self.y
				xx=xx+math.random(1,range)-math.random(1,range)
				yy=yy+math.random(1,range)-math.random(1,range)
				parse('explosion ' .. xx .. ' ' .. yy .. ' ' .. erange .. ' ' .. dmg .. ' 0')
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 0 0 255")
				radiussound("cs2d_tibia/blizz.ogg", self.x, self.y)
				gr = gr + 1
			until gr >= rept
		end},
	}, 
	{
		name = 'Ice Monster', health = 1250, image = 'gfx/weiwen/pokemon/e15.png', scalex = 0.8, scaley = 1.0, 
		atk = 10, def = 1.08, spd = 18, atkspd = 14, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 30, runat = 0, range = 48, spawn1 = {2, 172}, spawn2 = {69, 198}, 
		exp = 800, money = 1000, loot = {},
	}, 
	{
		name = 'Cold Beast', health = 11000, image = 'gfx/weiwen/pokemon/e19.png', scalex = 3, scaley = 3, 
		atk = 50.0, def = 1.2, spd = 23, atkspd = 18, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 15, runat = 20, spawn1 = {215, 9}, spawn2 = {239, 30}, 
		exp = 5000, money = 20000, loot = {{ chance = 1000 , id = 167},{ chance = 1000 , id = 171},{ chance = 2000 , id = 172},{ chance = 1000 , id = 173},{ chance = 1000 , id = 170},{ chance = 1000 , id = 169},{ chance = 1000 , id = 168}},
		spc = {2500, function(self, id, dist) 
			if not self.agility then
				radiusmsg("Cold Beast rages!", self.x, self.y)
				parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 000 000 000")
				radiussound("weapons/g_flash.wav", self.x, self.y)
				self.spd = 28
				self.atk = 65
				self.agility = true
				imagecolor(self.image, 255, 155, 155)
				addtimer(5000, function(self)
					self.spd = 30
					self.atk = 50
					imagecolor(self.image, 255, 255, 255)
					self.agility = nil
				end, self)
			elseif dist <= 32 then
				self:hit(id, 10)
			end
		end},  
	},
	{
		name = 'Fairy Boss', health = 22000, image = 'gfx/weiwen/pokemon/e21.png', scalex = 1, scaley = 1, 
		atk = 75.0, def =1.1, spd = 29, atkspd = 19, x = 0, y = 0, ang = 0, imgang = 0, range = 48, spawnchance = 15, runat = 20, spawn1 = {53, 160}, spawn2 = {71, 175}, 
		exp = 10000, money = 35000, loot = {{chance = 1000, id = 174},{ chance = 1000 , id = 175},{ chance = 1000 , id = 176},{ chance = 1000 , id = 177},{ chance = 1000 , id = 178},{ chance = 1000 , id = 179},{ chance = 1000 , id = 180}},
	},
	{
		name = 'Fairy', health = 4000, image = 'gfx/weiwen/pokemon/e21.png', scalex = 0.5, scaley = 0.5, 
		atk = 20.0, def = 1.1, spd = 25, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 30, runat = 20, spawn1 = {53, 160}, spawn2 = {71, 175}, 
		exp = 1900, money = 5000, loot = {},
	}, 
	{
		name = 'Magma Bird', health = 45000, image = 'gfx/weiwen/pokemon/162.png', scalex = 2, scaley = 2, 
		atk = 80.0, def =1.3, spd = 35, atkspd = 25, x = 0, y = 0, ang = 0, imgang = 0, range = 64, spawnchance = 10, runat = 20, spawn1 = {230, 173}, spawn2 = {272, 192}, 
		exp = 15000, money = 50000, loot = {{chance = 900, id = 184},{ chance = 900 , id = 185},{ chance = 900 , id = 186},{ chance = 900 , id = 187},{ chance = 900 , id = 188},{ chance = 900 , id = 189},{ chance = 900 , id = 190}},
				spc = {60, function(self, id, dist) 
			radiusmsg("The Magma Bird spits lava towards you!", self.x, self.y)
			local x1, y1 = self.x, self.y
			local rot = math.atan2(player(id, 'y')-y1, player(id, 'x')-x1) + math.pi/2
			local x2, y2 = math.sin(rot), -math.cos(rot)
			local fire = image("gfx/sprites/spot.bmp", 0, 0, 1)
			imagepos(fire, x1+x2*64, y1+y2*64, math.deg(rot)+180)
			imagescale(fire, 1.5, 2)
			imagecolor(fire, 255, 64, 0)
			imageblend(fire, 1)
			addtimer(500, freeimage, fire)
			parse('explosion ' .. x1+x2*100 .. ' ' .. y1+y2*100 .. ' 120 85')
			parse('explosion ' .. x1+x2*50 .. ' ' .. y1+y2*50 .. ' 100 85')
		end},
	},
	{
		name = 'Robot', health = 70000, image = 'gfx/weiwen/pokemon/robo.png', scalex = 0.9, scaley = 0.9, 
		atk = 110.0, def =1.35, spd = 40, atkspd = 32, x = 0, y = 0, ang = 0, imgang = 0, range = 64, spawnchance = 10, runat = 20, spawn1 = {245, 131}, spawn2 = {278, 155}, 
		exp = 25000, money = 80000, loot = {{chance = 800, id = 191},{ chance = 800 , id = 192},{ chance = 800 , id = 193},{ chance = 800 , id = 194},{ chance = 800 , id = 195},{ chance = 800 , id = 196},{ chance = 2800 , id = 197}},
				spc = {500, function(self, id, dist) 
			local range,dmg,erange,rept,gr,xx,yy = 200,30,128,math.random(10,20),0,self.x,self.y
			radiusmsg("The Robot fires rockets!", self.x, self.y)
			radiussound("materials/glass3.wav", self.x, self.y)
			repeat
				xx,yy=self.x,self.y
				xx=xx+math.random(1,range)-math.random(1,range)
				yy=yy+math.random(1,range)-math.random(1,range)
				parse('explosion ' .. xx .. ' ' .. yy .. ' ' .. erange .. ' ' .. dmg .. ' 0')
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 0 0 255")
				radiussound("cs2d_tibia/blizz.ogg", self.x, self.y)
				gr = gr + 1
			until gr >= rept
		end},
	},
	{
		name = 'Phoenix', health = 130000, image = 'gfx/weiwen/pokemon/boss 3.png', scalex = 1.8, scaley = 1.8, 
		atk = 160.0, def =1.4, spd = 45, atkspd = 38, x = 0, y = 0, ang = 0, imgang = 0, range = 64, spawnchance = 10, runat = 20, spawn1 = {215, 95}, spawn2 = {241, 124}, 
		exp = 30000, money = 130000, loot = {{chance = 750, id = 240},{ chance = 750 , id = 241},{ chance = 750 , id = 242},{ chance = 750 , id = 243},{ chance = 750 , id = 244},{ chance = 750 , id = 245},{ chance = 750 , id = 246}},
			spc = {500, function(self, id, dist) 
			parse('explosion ' .. self.x .. ' ' .. self.y .. ' 10 -20000')
			parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 0 255 255")
			radiusmsg("The Phoenix heals itself with its tears!", self.x, self.y)
			radiussound("muhaha.wav", self.x, self.y)
		end},
	},
	{
		name = 'Wizard', health = 300000, image = 'gfx/weiwen/pokemon/Sorcerer.png', scalex = 1.7, scaley = 1.7, 
		atk = 230.0, def =1.575, spd = 45, atkspd = 40, x = 0, y = 0, ang = 0, imgang = 0, range = 70, spawnchance = 15, runat = 0, spawn1 = {292, 203}, spawn2 = {347, 218}, 
		exp = 35000, money = 220000, loot = {{chance = 750, id = 247},{ chance = 750 , id = 248},{ chance = 750 , id = 249},{ chance = 750 , id = 250},{ chance = 750 , id = 251},{ chance = 750 , id = 252},{ chance = 750 , id = 253},{ chance = 750 , id = 254},{ chance = 750 , id = 255}},
				spc = {500, function(self, id, dist) 
			local range,dmg,erange,rept,gr,xx,yy = 200,40,128,math.random(10,20),0,self.x,self.y
			radiusmsg("The Wizard gets mad and uses forbidden magic!", self.x, self.y)
			radiussound("materials/glass3.wav", self.x, self.y)
			repeat
				xx,yy=self.x,self.y
				xx=xx+math.random(1,range)-math.random(1,range)
				yy=yy+math.random(1,range)-math.random(1,range)
				parse('explosion ' .. xx .. ' ' .. yy .. ' ' .. erange .. ' ' .. dmg .. ' 0')
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 0 0 255")
				radiussound("cs2d_tibia/blizz.ogg", self.x, self.y)
				gr = gr + 1
			until gr >= rept
		end},
	},
	
	{
		name = 'Dark Beast', health = 750000, image = 'gfx/weiwen/pokemon/189.png', scalex = 1.2, scaley = 1.2, 
		atk = 470.0, def =1.65, spd = 50, atkspd = 40, x = 0, y = 0, ang = 0, imgang = 0, range = 90, spawnchance = 15, runat = 0, spawn1 = {10, 229}, spawn2 = {30, 252}, 
		exp = 40000, money = 300000, loot = {{chance = 700, id = 256},{ chance = 700 , id = 257},{ chance = 700 , id = 258},{ chance = 700 , id = 259},{ chance = 700 , id = 260},{ chance = 700 , id = 261},{ chance = 700 , id = 262},{ chance = 700 , id = 264}},
				spc = {2500, function(self, id, dist) 
			if not self.agility then
				radiusmsg("Dark Beast rages!", self.x, self.y)
				parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 000 000 000")
				radiussound("weapons/g_flash.wav", self.x, self.y)
				self.spd = 60
				self.atk = 600
				self.agility = true
				imagecolor(self.image, 255, 155, 155)
				addtimer(5000, function(self)
					self.spd = 24
					self.atk = 50
					imagecolor(self.image, 255, 255, 255)
					self.agility = nil
				end, self)
			end
		end},
	},
	
	{
		name = 'Holy Warrior', health = 3000000, image = 'gfx/weiwen/pokemon/e4.png', scalex = 1.7, scaley = 1.7, 
		atk = 1800.0, def =1.85, spd = 52, atkspd = 44, x = 0, y = 0, ang = 0, imgang = 0, range = 120, spawnchance = 15, runat = 0, spawn1 = {320, 226}, spawn2 = {345, 248}, 
		exp = 54000, money = 9000000, loot = {{ chance = 700 , id = 271},{ chance = 700 , id = 272},{ chance = 700 , id = 273},{ chance = 700 , id = 274},{ chance = 700 , id = 275},{ chance = 700 , id = 276}},
			spc = {500, function(self, id, dist) 
			parse('explosion ' .. self.x .. ' ' .. self.y .. ' 10 -100000')
			parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 0 255 255")
			radiusmsg("The Holy Warrior gets healed by divine help!", self.x, self.y)
			radiussound("muhaha.wav", self.x, self.y)
		end},d
	},
	
	{
		name = 'Dimensional Anomally', health = 1500000, image = 'gfx/weiwen/pokemon/dimensional_anomally.png', scalex = 1.7, scaley = 1.7, 
		atk = 900.0, def =1.8, spd = 52, atkspd = 44, x = 0, y = 0, ang = 0, imgang = 0, range = 110, spawnchance = 15, runat = 0, spawn1 = {263, 227}, spawn2 = {303, 238}, 
		exp = 47000, money = 500000, loot = {{chance = 700, id = 270},{ chance = 700 , id = 269},{ chance = 700 , id = 268},{ chance = 700 , id = 267},{ chance = 700 , id = 266},{ chance = 700 , id = 265}},
			spc = {500, function(self, id, dist) 
			parse('explosion ' .. self.x .. ' ' .. self.y .. ' 10 -100000')
			parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 0 255 255")
			radiusmsg("The Holy Warrior gets healed by divine help!", self.x, self.y)
			radiussound("muhaha.wav", self.x, self.y)
		end},
	},
	
	{
		name = 'Dark Angel', health = 7000000, image = 'gfx/weiwen/pokemon/fallen_angel.png', scalex = 1.7, scaley = 1.7, 
		atk = 1500.0, def =1.9, spd = 57, atkspd = 48, x = 0, y = 0, ang = 0, imgang = 0, range = 130, spawnchance = 15, runat = 0, spawn1 = {124, 227}, spawn2 = {184, 242}, 
		exp = 60000, money = 1500000, loot = {{chance = 650, id = 277},{ chance = 650 , id = 278},{ chance = 650 , id = 279},{ chance = 650 , id = 280},{ chance = 650 , id = 281},{ chance = 650 , id = 282},{ chance = 650 , id = 283}},
				spc = {500, function(self, id, dist) 
			local range,dmg,erange,rept,gr,xx,yy = 200,70,128,math.random(10,20),0,self.x,self.y
			radiusmsg("The Dark Angel uses demonic magic!", self.x, self.y)
			radiussound("materials/glass3.wav", self.x, self.y)
			repeat
				xx,yy=self.x,self.y
				xx=xx+math.random(1,range)-math.random(1,range)
				yy=yy+math.random(1,range)-math.random(1,range)
				parse('explosion ' .. xx .. ' ' .. yy .. ' ' .. erange .. ' ' .. dmg .. ' 0')
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 0 0 255")
				radiussound("cs2d_tibia/blizz.ogg", self.x, self.y)
				gr = gr + 1
			until gr >= rept
		end},
	},
	
	{
		name = 'Poison Hydra', health = 15000000, image = 'gfx/weiwen/pokemon/hydra.png', scalex = 1.7, scaley = 1.7, 
		atk = 3500.0, def = 2.5, spd = 57, atkspd = 48, x = 0, y = 0, ang = 0, imgang = 0, range = 140, spawnchance = 15, runat = 0, spawn1 = {215, 227}, spawn2 = {232, 242}, 
		exp = 65000, money = 2000000, loot = {{chance = 600, id = 286},{chance = 600, id = 287},{chance = 600, id = 288},{chance = 600, id = 289},{chance = 600, id = 290},{chance = 600, id = 291},{chance = 600, id = 292}},
				spc = {500, function(self, id, dist) 
			local range,dmg,erange,rept,gr,xx,yy = 200,70,128,math.random(10,20),0,self.x,self.y
			radiusmsg("The Poison Hydra uses venomous fangs!", self.x, self.y)
			radiussound("materials/glass3.wav", self.x, self.y)
			repeat
				xx,yy=self.x,self.y
				xx=xx+math.random(1,range)-math.random(1,range)
				yy=yy+math.random(1,range)-math.random(1,range)
				parse('explosion ' .. xx .. ' ' .. yy .. ' ' .. erange .. ' ' .. dmg .. ' 0')
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 0 0 255")
				radiussound("cs2d_tibia/blizz.ogg", self.x, self.y)
				gr = gr + 1
			until gr >= rept
		end},
	},
	
	{
		name = 'Black Dragon', health = 25000000, image = 'gfx/weiwen/pokemon/e2.png', scalex = 1.7, scaley = 1.7, 
		atk = 7000.0, def =2.1, spd = 60, atkspd = 53, x = 0, y = 0, ang = 0, imgang = 0, range = 85,  spawnchance = 10, runat = 0, spawn1 = {81, 224}, spawn2 = {100, 252}, 
		exp = 70000, money = 350000, loot = {{chance =600, id = 293},{ chance = 600 , id = 294},{ chance = 600 , id = 295},{ chance = 600 , id = 296},{ chance = 600 , id = 297},{ chance = 600 , id = 298},{ chance = 600 , id = 299}},
				spc = {60, function(self, id, dist) 
			radiusmsg("The Black Dragon throws black fire!", self.x, self.y)
			local x1, y1 = self.x, self.y
			local rot = math.atan2(player(id, 'y')-y1, player(id, 'x')-x1) + math.pi/2
			local x2, y2 = math.sin(rot), -math.cos(rot)
			local fire = image("gfx/sprites/spot.bmp", 0, 0, 1)
			imagepos(fire, x1+x2*64, y1+y2*64, math.deg(rot)+180)
			imagescale(fire, 1.5, 2)
			imagecolor(fire, 255, 64, 0)
			imageblend(fire, 1)
			addtimer(500, freeimage, fire)
			parse('explosion ' .. x1+x2*100 .. ' ' .. y1+y2*100 .. ' 120 98')
			parse('explosion ' .. x1+x2*50 .. ' ' .. y1+y2*50 .. ' 100 98')
		end},
	},
	
	
	{
		name = 'Dark Hero', health = 100000000, image = 'gfx/weiwen/pokemon/legendaryhero.png', scalex = 1.7, scaley = 1.7, 
		atk = 19000.0, def =2.6, spd = 63, atkspd = 53, x = 0, y = 0, ang = 0, imgang = 0, range = 100,  spawnchance = 10, runat = 0, spawn1 = {214, 75}, spawn2 = {238, 85}, 
		exp = 110000, money = 1000000, loot = {{chance =500, id = 301},{ chance = 500 , id = 302},{ chance = 500 , id = 303},{ chance = 500 , id = 304},{ chance = 500 , id = 305},{ chance = 500 , id = 306},{ chance = 500 , id = 307}},
				spc = {2500, function(self, id, dist) 
			if not self.agility then
				radiusmsg("The Dark Hero rages and heals himself!", self.x, self.y)
				parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 000 000 000")
				radiussound("weapons/g_flash.wav", self.x, self.y)
				parse('explosion ' .. self.x .. ' ' .. self.y .. ' 10 -20000000')
				self.spd = 65
				self.atk = 40000.0
				self.agility = true
				imagecolor(self.image, 255, 155, 155)
				addtimer(5000, function(self)
					self.spd = 63
					self.atk = 19000.0
					imagecolor(self.image, 255, 255, 255)
					self.agility = nil
				end, self)
			end
		end},
	},
	
	{
		name = 'Tree', health = 300, image = 'gfx/weiwen/pokemon/e17.png', scalex = 1.9, scaley = 2.2, 
		atk = 1.8, def = 1.0, spd = 11, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 15, runat = 0, range = 36, spawn1 = {2, 85}, spawn2 = {25, 105}, 
		exp = 50, money = 240, loot = {{chance = 1000, id = 108},{chance = 1000, id = 109},{chance = 1000, id = 110},{chance = 1000, id = 111},{chance = 1000, id = 113},{chance = 1000, id = 112},{chance = 1000, id = 114},{chance = 1000, id = 115}},
		spc = {1000, function(self, id, dist) 
			if not self.rage then
				radiusmsg("The tree gets angry!", self.x, self.y)
				parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 255 155 155")
				radiussound("weapons/g_flash.wav", self.x, self.y)
				self.def = 3.3
				self.rage = true
				imagecolor(self.image, 255, 155, 155)
				addtimer(5000, function(self)
					self.atk = 2.2
					imagecolor(self.image, 255, 255, 255)
					self.rage = nil
				end, self)
			elseif dist <= 96 then
				radiusmsg("Tree hits you with it's roots!", self.x, self.y)
				self:hit(id, 20)
			end
		end},
	}
}

addhook("attack", "MONSTERattack")
function MONSTERattack(id)
	if gettile(PLAYERS[id].x, PLAYERS[id].y).SAFE then
		return
	end
	local weapon, closest = player(id, 'weapontype')
	for _, m in ipairs(MONSTERS) do
		local x, y = player(id, 'x'), player(id, 'y')
		local dist = math.sqrt((m.x-x)^2+(m.y-y)^2)
		if dist <= (closest and closest[2] or (CONFIG.WEAPONRANGE[weapon] or CONFIG.WEAPONRANGE[50])) then
			local rot = player(id, 'rot')
			if math.abs(math.rad(rot) - math.atan2(y-m.y, x-m.x) + math.pi/2)%(2*math.pi) <= (CONFIG.WEAPONWIDTH[weapon] or CONFIG.WEAPONRANGE[50]) then
				if free_line(player(id,"x"),player(id,"y"),m.x,m.y) then
					--msg(string.char(169).."000255000Yes, the path from your character to your monster is clear.")
					closest = {m, dist}
				else
					--msg(string.char(169).."255000000No, the path from your character to your monster is not clear.")
				end
			end
		end
	end
	if closest then
		closest[1]:damage(id, math.ceil(20*((PLAYERS[id].Level+50)*PLAYERS[id].tmp.atk/closest[1].def)/math.random(60, 140)), weapon)
		end
end


addhook("ms100", "MONSTERms100")
function MONSTERms100()
	t = t + 1
	if t % 100 == 0 then
		while #MONSTERS < CONFIG.MAXMONSTERS do
			local rand
			repeat 
				rand = math.random(#CONFIG.MONSTERS)
			until math.random(0, 100) < CONFIG.MONSTERS[rand].spawnchance
			local m = deepcopy(CONFIG.MONSTERS[rand])
			local x, y, tilex, tiley
			repeat
				if m.spawn1 then
					tilex, tiley = math.random(m.spawn1[1], m.spawn2[1]), math.random(m.spawn1[2], m.spawn2[2])
				else
					tilex, tiley = math.random(map'xsize'), math.random(map'ysize')
				end
			until not gettile(tilex, tiley).SAFE and not gettile(tilex, tiley).PVP and tile(tilex, tiley, "walkable") and tile(tilex, tiley, "frame") ~= 34
			m.x, m.y = math.floor(tilex*32+16), math.floor(tiley*32+16)
			Monster:new(m)
		end
	end
	for _, m in ipairs(MONSTERS) do
		if t % m.atkspd == 0 then
			m.target = nil
			local closest
			for _, p in ipairs(table.shuffle(player(0, 'table'))) do
				if player(p, 'health') > 0 and not gettile(PLAYERS[p].x, PLAYERS[p].y).SAFE then
					local dist = math.sqrt((player(p, 'x')-m.x)^2 + (player(p, 'y')-m.y)^2)
					if dist < 400 then
						if not closest or dist < closest[2] then
							closest = {p, dist}
						end
					end
				end
			end
			if closest then
				local dist = closest[2]
				if dist < 400 then
					m.target = closest[1]
					if m.spc and math.random(10000) <= m.spc[1] then
						m.spc[2](m, m.target, dist)
					elseif dist <= (m.range or 32) then
						m:hit(m.target, 10)
					end
				end
			end
		end
		m.imgang = math.sin(t/2.5*math.pi) * 15
		if m.target and player(m.target, 'exists') and player(m.target, 'health') > 0 and not gettile(PLAYERS[m.target].x, PLAYERS[m.target].y).SAFE then
			xdist, ydist = player(m.target, 'x') - m.x, player(m.target, 'y') - m.y
			local dist = math.sqrt(xdist^2 + ydist^2)
			if dist < 400 then
				m.ang = math.atan2(ydist, xdist)-math.pi/2+math.random(-1, 1)/2
			else
				m.target = nil
			end
		end
		if not m.target then
			m:rot(math.random(-1, 1)/2)
		end
		if not m:move(m:rot(), m.health > m.runat and 1 or -1) then
			repeat until m:move(math.rad(math.random(360)), 1)
		end
	end
	
	if MONSTERESET == 0 or requestmonstereset == 1 then
		MONSTERESET = 1
		if MINUTES%30 == 0 or requestmonstereset == 1 then
			for _, m in ipairs(MONSTERS) do
				m:restart()
				requestmonstereset = 0
			end
			msg('100100255 MONSTER RESET @C')
		end
	end

end


function Monster:new(m)
	if not (m.x or m.y) then return false end
	m.image = image(m.image, m.x, m.y, 0)
	imagescale(m.image, m.scalex, m.scaley)
	setmetatable(m, self)
	self.__index = self
	table.insert(MONSTERS, m)
	m.id = #MONSTERS
	return m
end

function Monster:pos(x, y)
	if not x and not y then
		return self.x, self.y
	else
		self.x, self.y = x or self.x, y or self.y
		imagepos(self.image, self.x, self.y, self.imgang)
	end
	return true
end

function Monster:move(dir, amt)
	local x, y = -math.sin(dir)*amt*self.spd, math.cos(dir)*amt*self.spd
	local x, y = self.x+x, self.y+y
	local tilex, tiley = math.floor(x/32), math.floor(y/32)
	if tile(tilex, tiley, 'walkable') and tile(tilex, tiley, 'frame') ~= 34 and not gettile(tilex, tiley).SAFE then
		self:pos(x, y)
		return true
	else
		self:rot(math.random(-1, 1)*math.pi/2)
		return false
	end
end

function Monster:damage(id, dmg, wpntype)
	if not PLAYERS[id].Tutorial.damagem then
		message(id, "You have attacked a monster! Good job! Keep on attacking it until it dies.", "255128000")
		PLAYERS[id].Tutorial.damagem = true
	end
	local wpnName
	if weapon == 251 then
		wpnName = 'rune'
	elseif weapon == 46 then
		wpnName = 'firewave'
		dmg = dmg/5
	else
		wpnName = PLAYERS[id].Equipment[3] and ITEMS[PLAYERS[id].Equipment[3]].name or 'dagger'
	end
	self.health = self.health - dmg
	hudtxt2(id,15,"You deal " .. dmg .. " damage", '255255255', 530, 365-CONFIG.PIXELS, 1)
	hudtxt2(id,16, self.name .. " still has " .. self.health .. " hp", '255255255', 530, 380-CONFIG.PIXELS, 1)
	PLAYERS[id].tmp.equip[3].monstermessage = 0
	PLAYERS[id].tmp.equip[3].domonstermessage = 1
	--print(player(id, 'name') .. ' deals ' .. dmg .. ' damage to ' .. self.name .. ' using a ' .. wpnName .. '.')
	if self.health <= 0 then
		if not PLAYERS[id].Tutorial.killm then
			message(id, "Congratulation! You have killed your first monster. You can proceed to pick up the loot by using the drop weapon button (default G)", "255128000")
			PLAYERS[id].Tutorial.killm = true
		end
		addexp(id, math.floor(self.exp*CONFIG.EXPRATE))
		self:die()
	else
		parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 0 ' .. self.scaley .. ' ' .. (self.r and (self.r .. ' ' .. self.g .. ' ' .. self.b) or '192 0 0'))
	end
	radiussound("weapons/machete_hit.wav", self.x, self.y)
	return true
end

function Monster:hit(id, dmg)
	if not PLAYERS[id].Tutorial.hitm then
		message(id, "A monster is attacking you! You can fight back by swinging your weapon at it.", "255128000")
		PLAYERS[id].Tutorial.hitm = true
	end
	if player(id, 'weapontype') == 41 and (math.abs(math.rad(player(id, 'rot')) - math.atan2(player(id, 'y')-self.y, player(id, 'x')-self.x) + math.pi/2)%(2*math.pi) <= math.pi*2/3) then
		EXPhit(id, self, -1, dmg/4)
		radiussound("weapons/ricmetal" .. math.random(1,2) .. ".wav", self.x, self.y)
	else
		EXPhit(id, self, -1, dmg)
		radiussound("weapons/knife_hit.wav", self.x, self.y)
	end
	return true
end

function Monster:die(id)
	local size = self.scalex+self.scaley
	parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' ' .. size .. ' 64 ' .. (self.r and (self.r .. ' ' .. self.g .. ' ' .. self.b) or '192 0 0'))
	local tilex, tiley = math.floor(self.x/32), math.floor(self.y/32)
	spawnitem(1337, tilex, tiley, math.floor(self.money*math.random(50, 150)/100)*CONFIG.MONEYRATE)
	for _, loot in ipairs(self.loot) do
		local chance = math.random(10000)
		if chance <= loot.chance then
			spawnitem(loot.id, tilex, tiley)
		end
	end
	radiussound("weapons/c4_explode.wav", self.x, self.y)
	self:destroy()
end

function Monster:restart()
	local size = self.scalex+self.scaley
	parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' ' .. size .. ' 64 ' .. (self.r and (self.r .. ' ' .. self.g .. ' ' .. self.b) or '192 0 0'))
	radiussound("weapons/c4_explode.wav", self.x, self.y)
	self:destroy()
end

function Monster:destroy()
	freeimage(self.image)
	local found
	table.remove(MONSTERS, self.id)
	for i, m in ipairs(MONSTERS) do
		m.id = i
	end
	return true
end

function Monster:rot(rot)
	if not rot then
		return self.ang
	else
		self.ang = (self.ang+rot)%(math.pi*2)
	end
	return true
end